require "gamedata/lua/debug"

require "gamedata/lua/locale"
local qrcode= require("gamedata/lua/qrcode/qrcode.lua")

--全局变量
g_isDebug	= g_isDebug or false	-- 是否是debug模式
singleRechargeTy = 40

XPlatformConfig = XPlatformConfig or {} --用在SDK上面的全局配置,可以通过特殊的方式从底层传上来

function lua_GetAppName()

	local osver = lua_baidu_stat("appname")
	if osver == nil then
		if JavaGetAppName then
			return JavaGetAppName()
		else
			return "na"
		end
	else
		return osver
	end
end


function covertMsg(msg)

	if type(msg) == "string" then
		return msg
	end

	local ret = nil
	xpcall(function()
		ret = tostring(msg)
	end,function(errMsg)
		ret = "Unknow struct and failed to covert it to string"
	end)

	return ret
end

function isRightJson(str)
	if type(str)=="string" and str~="" and string.sub(str,1,1)=="{" then
		return true
	end
	return false
end

function getRemoteSDKConfig(apkInfo)

	do return nil end
	local ret = {}

	return ret
end

function isLp()

	if getSDKName() == "SHUYOUSDK" or getSDKName()=="HUOSUSDK" or getSDKName() == "ANDROID_METAFALICA" then
		return true
	end

	return false

end

function isYiJieSDK()
	local sdkName = getSDKName()
	if sdkName == "SHUYOUSDK" or sdkName == "YIJIE996" or sdkName == "CYQQBSGSDK" then
		return true
	end

	return false 
end

function isHuoSuSDK()
	local sdkName = getSDKName()
	if sdkName == "HUOSUSDK" then
		return true
	end

	return false 
end

function sdkUIControlAble()
	if useNewSDKInterface and type(useNewSDKInterface) == "function" then
		--[[
			新版本的sdk启动流程
			平台层应用程序启动成功 
				程序创建
				appDelgate
				注册通用SDK接入接口
			启动游戏
				显示游戏界面并在此之前将sdkName强制设置为 "NEWSDKINTERFACE"以跳过旧接口
				链接版本控制服务器以选择要使用的SDK
				进行sdk切换,无法进行sdk切换的则跳过使用默认SDK
			进入平台SDK层
				进入选择好的SDK并尝试装载其他模块
				回调lua通知自己的身份和SDK配置
			lua层开始装载SDK
				显示界面 (这一步可能会导致未初始化接口崩溃)
				调用初始化
					成功:
						SDK是否有登陆接口
							有:调用登陆接口
								成功:获取登陆参数,并上报登陆服务器以取得用户信息
								失败:重试登陆
							无:用内置登陆系统以及其流程
					失败:
						上报版本控制服务器
				其他流程:	
					调用支付
					登出:清空g_user_json和initSDK

		]]

		local apkInfo = getApkInfo()

		local sdkConfig = getRemoteSDKConfig(apkInfo)

		if not sdkConfig then
			hardLog("---[getRemoteSDKConfig return a nil value]---")
			logForUser(ls('启动游戏内核失败,请重试(包括但不限于,切换网络环境,通知客服)'))
			sdkConfig = {}
			sdkConfig["name"]="normal"--使用默认的sdk类型
			sdkConfig["requireFile"]="gamedata/lua/sdk/sdk_metafalica" --要强制装载的sdk文件名	
		end

		--[[
		这里还要和最顶层交互一下配置
		]]
		require "gamedata/lua/sdk/sdk_metafalica"


		setGlobalSDKConfig(sdkConfig)

		sdk = getSDKInstance(sdkConfig)

		if not sdk then
			hardLog("---[getSDKInstance return a nil value]---")
			logForUser(ls('获取游戏配置信息失败,请重试'))
			forceCarsh()
			return
		end

		sdk:metafalica()
		return

	end
end
function isQKQKDispathPackage_ttbsg(sdkName)

	if not sdkName then
		return false
	end

	local ret = 
			(sdkName == "QKTTBSG_GJZSG_SDK") or (sdkName  == "QKTTBSG_LBZDC_SDK") or (sdkName  == "QKTTBSG_LDSG_SDK") or
			(sdkName  == "QKTTBSG_HSSG_SDK") or (sdkName  == "QKTTBSG_DQSG_SDK") or (sdkName == "QKTTBSG_QYLD_SDK") or
			(sdkName == "QKTTBSG_MJZSG_SDK")  or (sdkName == "QKTTBSG_QMSGXXB_SDK") or (sdkName == "QKTTBSG_QMSG_SDK") or
			(sdkName == "QKTTBSG_GJZQY_SDK")  or (sdkName == "QKTTBSG_MJZSG_SDK") or (sdkName == "QKTTBSG_ZGDHJ_SDK") or
			(sdkName == "QKTTBSG_WHZSG_SDK") or (sdkName == "QKTTBSG_GJZMJ_SDK") or (sdkName == "QKTTBSG_MJDQY_SDK") or
			(sdkName == "QKTTBSG_GJDQX_SDK")

	if not ret then
		if qkqkBSG then
			return true
		end
	end
	
	return ret

end

--判断json字符串是否有效
function isVaildJson(str)
	if type(str)=="string" and str~="" and string.sub(str,1,1)=="{" then
		return true
	end
	return false
end

--某些时候cclog无法使用时使用这个日志功能
function hardLog(str,...)
	print(str)
end

function myXpcall(fn)

	fn()
	return true

end

function isCYQQ()

	local sdkName = getSDKName()

	if sdkName == "IOS_TTBSG_CYQQ" or sdkName == "CYQQBSGSDK" then
		return true
	end

	return false

end

function is996()

	local sdkName = getSDKName()
	if sdkName == "IOS996" or sdkName == "996SDK" or sdkName == "U3733SDK" or sdkName == "DAMAIECSDK" or sdkName == "YIJIE996" then
		return true	
	end

	return false
end

function is185()

	if ttbsg185Ver and type(ttbsg185Ver) == "function" then
		return true
	end
	
	local sdkName = getSDKName()
	if sdkName == "SY185SDK" then
		return true
	end

	return false
end

function is7k7k()

	local sdkName = getSDKName()

	if isQKQKDispathPackage_ttbsg(sdkName) then
		return true
	end

	return false
end

function isShanyou()

	local sdkName = getSDKName()
	if sdkName == "SHANYOUNEWSDK" then
		return true
	end

	return false
end

function logForUser(str,...)
	hardLog(str, ...)
end

function getApkInfo()

	local appVer = lua_GetVersion()

	local apkInfo = {}

	apkInfo["app"]=lua_GetAppName() --包名
	apkInfo["ver"]=g_apkVersion --第一次出包的版本
	apkInfo["appVer"]=appVer --包的版本
	apkInfo["curVer"]=g_version --程序当前的版本
	apkInfo["sdkName"]=getSDKName() --sdk名
	apkInfo["sdkId"]=getSDKId() --sdk的id
	apkInfo["platform"]=CCApplication:sharedApplication():getTargetPlatform() --包是那个平台的
	apkInfo["platformVer"]=getPlatformVersion() --平台当前版本
	apkInfo["machineType"]=getMachineType() --机器的名字(比如iphone 4s)
	apkInfo["deviceId"]=getDeviceId() --机器id
	apkInfo["customId"]=getCustomId() --程序生成的id
	apkInfo["extra"]="nil" --自定义参数

	return apkInfo

end

function rebootGame(cleanLoginInfo)

	if cleanLoginInfo then
		g_isLogin_ok=false
		g_userJson = nil
	end

	LogoUI.LogoUI()

end

function makeUrlArgument(tb)

	local ret = ""
	for index,value in pairs(tb) do
		ret = ret..string.format("%s=%s&",tostring(index),tostring(value))
	end
	if string.len(ret) > 0 then
		ret = string.sub(ret,0,string.len(ret)-1)
	end
	return ret

end

function makeUrl(url,tb)

	local argStr = makeUrlArgument(tb)

	return string.format("%s?%s",url,argStr)

end


function isIosInsideLogin()

	if g_anysdk_agent and (g_anysdk_agent:getChannelId()=="160002" or g_anysdk_agent:getChannelId()=="160204") then
		return true
	end
	return false

end

function isYsd()

	local ret = false

	xpcall(function()
		ret = isIosInsideLogin() and g_anysdk_agent:getChannelId()=="160204"
	end,function(err)
		ret = false	
		debug_main(tostring(err))
	end)
	return ret

end

g_ItIsNewCommon = true

g_wpath=CCFileUtils:sharedFileUtils():getWritablePath()

--[[function getSDKName() --临时测试
	return "aa"
end]]
--g_isEnglish = true

--g_isDebug = true
g_guild_open_level=15

g_max_player_level=125

g_qiyu_level=20

g_BGM_MaxVolume = g_BGM_MaxVolume or 0.5

g_isInFengCe=false

if g_isEnglish then
	g_name_len=16
else
	g_name_len=12
end

__g_token_str="1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"

local preMsg=""
local preTime=0
function __G__TRACKBACK__(msg)
	--if true == g_isDebug then
		local traceback_info = debug.traceback()
		lerr_index = lerr_index or 0
		print("----------------------------------------")
		print("LUA ERROR: " .. tostring(msg) .. "\n")
		print(traceback_info)
		print("----------------------------------------")
		local str = "------ lua error "..lerr_index.." ------\n" .. tostring(msg) .. "\n" .. debug.traceback()
		lerr_index = lerr_index + 1
		if msg~=preMsg and os.time()-preTime>60 then
			preMsg=msg
			preTime=os.time()
			net.send(LUAERROR_MSG,tostring(traceback_info).."\n"..tostring(msg))
		end
		
		if g_isDebug then 
			debug_main(str)
		end
		--debug_main(str)
	--end
end

g_popTxt_tag=666
-- cclog

cclog = function(...)
	if g_isDebug then
		local  str = ""
		local  arg = {...}
		for n =1,#arg do
			str = str .." ".. tostring(arg[n])
		end
		--CCLOG(string.format(...))
		CCLuaLog(str)
		--io.write(string.format(...))
	end
end

function getTmpPath(  )
    return CCFileUtils:sharedFileUtils():getWritablePath() .. "sgtmp"
end
----------------------------------------------------------------------

require "gamedata/lua/CCBReaderLoad"
math.mod = math.fmod

g_backMusic			= g_backMusic or 0 -- 0: login 1: main 2: battle
g_fubenScene		= g_fubenScene or nil
g_slidePixels		= g_slidePixels or 20 			-- 滑动最低需要移动距离
g_slideScrollPixels = g_slideScrollPixels or 60		-- 滑页最低需要移动距离
g_popUp_Tag			= g_popUp_Tag or 123
g_doModal_tag		= g_doModal_tag or 8
g_wizardNote_tag	= g_wizardNote_tag or 456
g_socketLoad_tag	= g_socketLoad_tag or 389
g_buzhenZhandouli	= g_buzhenZhandouli or false--是否布阵时模拟计算战斗力，防止缘时不时跳出

g_item_list			= g_item_list or {}
g_fragment_list		= g_fragment_list or {}--阵法和书籍的碎片列表
g_equipFragment_list= g_equipFragment_list or {}--装备碎片
g_skill_list		= g_skill_list or {}
g_equip_list		= g_equip_list or {}
g_goods_list		= g_goods_list or {}


--不要在common.lua里面执行这三个函数,因为他们依赖的变量都还未初始化

--是否要进入电视版本的代码
function enterStbCode()

	return stb_config.isStbOpt

end

--是否要进入导量手机版本的代码
function enterExportPhoneCode()

	return g_exportPhone

end

--是否要进入电视版本或者导量手机版本的代码

function enterTvCode()

	return enterStbCode() or enterExportPhoneCode()

end

--电视版就直接WIFI来防止有线网络无法链接的问题,手机版本直接用C++代码里的getNetworkType
function getNetworkTypeNew()

	if enterStbCode() then

		return 4 --wifi

	end

	return getNetworkType()
end

function addSpriteFramesWithFileRGBA444(fn_plist,fn_png)
	local defaultFormat=CCTexture2D:defaultAlphaPixelFormat()
	CCTexture2D:setDefaultAlphaPixelFormat(kCCTexture2DPixelFormat_RGBA4444)
	CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile(fn_plist,fn_png)
	CCTexture2D:setDefaultAlphaPixelFormat(defaultFormat)
end

function addArmatureFileInfoRGBA444(fPng,fPlist,fEJ)
	local defaultFormat=CCTexture2D:defaultAlphaPixelFormat()
	CCTexture2D:setDefaultAlphaPixelFormat(kCCTexture2DPixelFormat_RGBA4444)
	CCArmatureDataManager:sharedArmatureDataManager():addArmatureFileInfo(fPng,fPlist,fEJ)
	CCTexture2D:setDefaultAlphaPixelFormat(defaultFormat)
end

function getContentSize(node,withoutScale)

    local size = node:getContentSize()

    return CCSize( size.width * node:getScaleX() , size.height * node:getScaleY() )

end

--数据变动接口-如果sdk需要且支持
function reportData(key,value)

	local info = {}
	info[key] = value
	reportTable(info)
	
end

function reportTable(info)

	if sdkReportData and type(sdkReportData) == "function" then
		sdkReportData(json.encode(info))
	end

end

--QC报告的错误信息由这里弹出
function QCErrorPop(code)

	if code == "QC-sync-data" then
		return popup_main(ls('数据不同步请重新登陆'))
	elseif code == "QC-sync-day" then
		return popup_main(ls('时区信息不同步'))
	elseif code == "QC-error-argument" then
		return popup_main(ls('传入服务器的参数错误'))
	elseif code == "QC-error-mission" then
		return popup_main(ls('无此任务'))
	elseif code == "QC-check" then
		return popup_main(ls('返回值异常'))
	elseif code == "QC-not-exist" then
		return popup_main(ls('不合法的道具'))
	elseif code == "QC-not-table" then
		return popup_main(ls('不合法的奖励描述'))
	elseif code == "QC-error-id" then
		return popup_main(ls('不合法的四选一目标道具'))
	elseif type(code) == "string" then
		popup_main(ls(code))
	else
		popup_main(ls('出错'))
	end

end

function letItVisible(node,visible)
    node:setVisible(visible)

    if not visible then
    	local x,y = node:getPosition()
    	node.wasPt = ccp(x,y)
    	node:setPosition(ccp(9999,9999))
    else
    	if node.wasPt then
    		node:setPosition(node.wasPt)
    	end
    end

end

function fuckCocosDeveloperAndCheckNodeTouchEnabledByVisible(node)

	local tmpNode = node

	local ret = true

	while ret and tmpNode do

		ret = tmpNode:isVisible()
		tmpNode = tmpNode:getParent()

	end

	return ret

end

function tipAction(node)

	kiraKira(node)

end

kiraTipTag = 998

function removeTipAction(node)

	if node:getActionByTag(kiraTipTag) then
		node:stopActionByTag(kiraTipTag)
		local action = CCTintTo:create(0.5,255,255,255)
		node:runAction(action)
	end

end

function kiraKira(node)

	if not node:getActionByTag(kiraTipTag) then

		local action1 = CCTintTo:create(0.5,184,41,200)

		local action2 = CCTintTo:create(0.5,255,255,255)

		local actionArray = CCArray:create()
		actionArray:addObject(action1)
		actionArray:addObject(action2)

		local action3 = CCRepeatForever:create(CCSequence:create(actionArray))
		action3:setTag(kiraTipTag)
		node:runAction(action3)

	end

end

function moveAndBounceOut(MainScene,time,open,after)

	if open then
		MainScene.sc1:setContentOffsetInDuration(ccp(0,0),time)
	else
		local length = MainScene.layer:getContentSize().width
		MainScene.sc1:setContentOffsetInDuration(ccp(length,0),time)
	end

	if after then
		scheduleScriptFuncOnce(after,time+0.2)
	end

end

			--判断次冲的红点显示
function checkRechargeTip(inCoFunc)

	function impl()

		local amount = net.rpc("vip.getRechargeMoreAmount")
				
		if net.rpc("vip.getRechargeMoreStatus",amount) == 2 then

			g_player_info.haveRechargeMore = true

		else
			
			g_player_info.haveRechargeMore = false

		end

	end

	if not inCoFunc then

		coFunc(function() --只有访问服务器才能知道是否有未领取的奖励

				impl()

		end)()

	else

		impl()

	end

end

function getChannelParam()
	if g_anysdk_agent then--anysdk
		local param=g_anysdk_agent:getCustomParam()
		if param and param~="" then
			return param
		end
		return g_anysdk_agent:getChannelId()
	elseif getCustomParam then--c++ export
		return getCustomParam()
	end
	return nil
end
--baidu统计

function lua_baidu_stat(id, p1, p2, p3)
	if nil ~= baiduStat then
		return baiduStat(id, p1 or "", p2 or "", p3 or "")
	end
end

--参数内容不要是中文
--充值
function BD_charge(orderId,iapId,amount,virtualAmount,paymentType)
	orderId=orderId or "xx"
	iapId=iapId or "xx"
	amount=amount or "0"
	virtualAmount=virtualAmount or "0"
	paymentType=paymentType or "0"
	local param=orderId .. "," .. iapId .. "," .. amount .. "," .. virtualAmount .. "," .. paymentType
    lua_baidu_stat("charge",param)
end

function SX_generateToken()
	local token="sx"
	local len = string.len(__g_token_str)
	for i=1,12 do
		local r=math.random(1,len)
		token = token .. string.sub(__g_token_str,r,r)
	end
	local fullPath = CCFileUtils:sharedFileUtils():getWritablePath().."cuid"
	local f = io.open(fullPath,"w")
	if nil == f then
		return token
	end
	f:write(token)
	f:close()
	return token
end

function SX_getCuid()
	if g_apkVersion and g_apkVersion>="0.21.0.0" then
		if JavaGetDeviceId then
			local p=JavaGetDeviceId()
			if p and p~="" then
				return p
			end
		end
	end
	local fullPath = CCFileUtils:sharedFileUtils():getWritablePath().."cuid"
	--get data from file
	local f=io.open(fullPath,"r")
	if nil==f then
		return SX_generateToken()
	end
	local fileContents = f:read("*all")
	f:close()
	if fileContents == "" or string.len(fileContents) then
		return SX_generateToken()
	end
	
	return fileContents	
end

--getCuid
function BD_getCuid()
	local cuid = lua_baidu_stat("getcuid")
	if cuid == nil then
		cuid = SX_getCuid()
	end
    return  cuid
end

function lua_GetDeviceModel()
	local mdl = lua_baidu_stat("model")
	if mdl == nil then
		if JavaGetDeviceModel then
			return JavaGetDeviceModel()
		else
			return "na"
		end
	else
		return mdl
	end
end

function lua_GetOSVer()
	local osver = lua_baidu_stat("osver")
	if osver == nil then
		if JavaGetOSInfo then
			return JavaGetOSInfo()
		else
			return "na"
		end
	else
		return osver
	end
end

function lua_GetAppName()
	local osver = lua_baidu_stat("appname")
	if osver == nil then
		if JavaGetAppName then
			return JavaGetAppName()
		else
			return "na"
		end
	else
		return osver
	end
end

function lua_GetVersion() --in manifest. not the one in version.lua!
	local osver = lua_baidu_stat("getver")
	if osver == nil then
		if JavaGetVersion then
			return JavaGetVersion()
		else
			return "na"
		end
	else
		return osver
	end
end

--自定义事件
function BD_event(id,label)
	lua_baidu_stat("event",id,label or "nil")
end
function BD_eventTime(id,label,dura)
    if type(dura) == "number" then
		local int_dura = math.floor(dura)
        lua_baidu_stat("evtime",id,label or "nil",tostring(int_dura))
    end
end
function BD_eventStart(id,label)
    lua_baidu_stat("evstart",id,label or "nil")
end
function BD_eventEnd(id,label)
    lua_baidu_stat("evend",id,label or "nil")
end

---------------------talkingdata begin--------------------------
function td_setaccount(id)
	if nil ~= TDGAAccount and nil ~= TalkingDataGA then
		cclog("TDGAAccount set account id: "..id)
		TDGAAccount:setAccount(id)
	end
end

function td_setaccountname(name)
	if nil ~= TDGAAccount and nil ~= TalkingDataGA then
		TDGAAccount:setAccountName(name)
	end
end

function td_setserver(name)
	if nil ~= TDGAAccount and nil ~= TalkingDataGA then
		TDGAAccount:setGameServer(name)
	end
end

function td_setlevel(lv)
	if nil ~= TDGAAccount and nil ~= TalkingDataGA then
		TDGAAccount:setLevel(lv)
	end
end

function td_onpurchase( id,num,price ) --price是单价
	if nil ~= TDGAAccount and nil ~= TalkingDataGA and nil ~= TDGAItem then
		TDGAItem:onPurchase(id,num,price)
	end
end

function td_onuse( id,num )
	if nil ~= TDGAAccount and nil ~= TalkingDataGA and nil ~= TDGAItem then
		TDGAItem:onUse(id,num)
	end
end

function td_onreward( num, desc )
	if nil ~= TDGAVirtualCurrency and nil ~= TalkingDataGA then
		TDGAVirtualCurrency:onReward(num,desc)
	end
end

function td_chargerequest(orderId,productName,money,moneyType,vmoney,payType)
    if nil ~= TDGAVirtualCurrency and nil ~= TalkingDataGA then
        TDGAVirtualCurrency:onChargeRequest(orderId,productName,money,moneyType,vmoney,payType)
    end
end

function td_onchargesuccess( orderid )
	if nil ~= TDGAVirtualCurrency and nil ~= TalkingDataGA then
		TDGAVirtualCurrency:onChargeSuccess( orderid )
	end
end
---------------------talkingdata end--------------------------

--玩家账号名，要唯一,没有可不设置，默认为机器id
function BD_setACId(id)
	cclog("set account id: "..id)
	lua_baidu_stat("aci",id)
end
--玩家账号名
function BD_setACName(name)
	lua_baidu_stat("acn",name)
end
--选择的服务器
function BD_setServer(name)
	lua_baidu_stat("svr",name or "error")
end
--玩家等级
function BD_setLevel(lv)
	if type(lv) == "number" then
		lua_baidu_stat("lv",tostring(lv))
	end
end
--切换关卡成功
function BD_changeFuBenWin(id)
	lua_baidu_stat("tskw",tostring(id))
end
--闯关失败
function BD_changeFuBenFailed(id)
	lua_baidu_stat("tskf",tostring(id))
end
--购买道具
function BD_purchase(id,num,price)
	lua_baidu_stat("buy",id,num,tostring(price or 0))
end
--使用道具
function BD_use(id,num)
	lua_baidu_stat("use",id,tostring(num or 0))
end

function registerObserver(pObj,fun,name)
	CCNotificationCenter:sharedNotificationCenter():registerScriptObserver(pObj,fun,name)
end

function unregisterObserver(pObj,name)
	CCNotificationCenter:sharedNotificationCenter():unregisterScriptObserver(pObj,name)
end

function postNotification(name)
	CCNotificationCenter:sharedNotificationCenter():postNotification(name)
end

function getSpriteFrameByName(name)
	return CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName(name)
end

function scheduleScriptFunc(handle,interval,paused)
	return CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(handle,interval,paused)
end

function unscheduleScriptEntry(scheduleScriptEntryID)
	return CCDirector:sharedDirector():getScheduler():unscheduleScriptEntry(scheduleScriptEntryID)
end

function scheduleScriptFuncOnce(handle,interval)
	local schId=0
	schId=scheduleScriptFunc(function ()
		unscheduleScriptEntry(schId)
		handle()
	end,interval,false)
end

function random_blue_hero(heroId)
 --[[   local id = tonumber(string.sub(heroId,3))
    CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("gamedata/hero/HB_pang_ss_fu.plist","gamedata/hero/HB_pang_ss_fu.png")
    CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("gamedata/hero/HB_pang_ds_fu.plist","gamedata/hero/HB_pang_ds_fu.png")
    CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("gamedata/hero/HB_pang_ss_chui.plist","gamedata/hero/HB_pang_ss_chui.png")
    CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("gamedata/hero/HB_pang_ds_chui.plist","gamedata/hero/HB_pang_ds_chui.png")
    local heroes = { "HB_pang_ss_fu", "HB_pang_ds_fu", "HB_pang_ss_chui", "HB_pang_ds_chui" }
    return heroes[math.mod(id, #heroes)+1]
	]]
	return "HA000"
end


--http://www.lua.org/pil/19.3.html
function pairsByKeys (t, f)
    local a = {}
    for n in pairs(t) do table.insert(a, n) end
    table.sort(a, f)
    local i = 0					-- iterator variable
    local iter = function ()	-- iterator function
        i = i + 1
        if a[i] == nil then return nil
        else return a[i], t[a[i]]
        end
    end
    return iter
end

function roundOff(fvalue)
    if nil==fvalue then
        return nil
    end
    local intV,floatV=math.modf(fvalue)
    if floatV>=0.5 then
        intV=intV+1
    end
    return intV
end
function roundOffV(fvalue)
    if nil==fvalue then
        return nil
    end
    local intV,floatV=math.modf(fvalue)
    if math.abs(floatV)>=0.5 then
        intV=intV-1
    end
    return intV
end
function copyTab(st)
    local tab = {}
    for k, v in pairs(st or {}) do
        if type(v) ~= "table" then
            tab[k] = v
        else
            tab[k] = copyTab(v)
        end
    end
    return tab
end

function tabIsEqual(t1,t2)
    if type(t1) ~= "table" or type(t2) ~= "table" then
        return false
    end
    if #t1~=#t2 then
        return false
    end
    for k, v in pairs(t1) do
        if type(v) ~= "table" then
            if t2[k] ~= v then
                return false
            end

        else
            if tabIsEqual(v,t2[k])==false then
                return false
            end
        end
    end
    return true
end

--增加箭头
function addArrows(node)
	if (not g_isInMain) or (not node) then
		return
	end
	if node:getChildByTag(19) ~= nil then 
		return
	end
	local sz = node:getContentSize()
	local jt=jiantou_main()
	jt:setPosition(ccp(sz.width/2,sz.height))
	jt:setTag(19)
	node:addChild(jt)
	return jt
end

function removeArrows(node)
	if node  and node:getChildByTag(19) ~= nil then 
		node:removeChildByTag(19,true)
	end
end

--增加红点
--G_BAG_FULL = 1	--背包满
--G_EQUIP_NEW  = 2	--新的高品级装备
function addRedtip(node,icoType,offsetX,offsetY)
	if (not g_isInMain) or (not node) then
		return
	end
	if not icoType and node:getChildByTag(18) ~= nil then 
		return
	elseif icoType then
		removeRedtip(node)
	end
	
	local redTips = nil
	if G_BAG_FULL == icoType then
		local  proxy = CCBProxy:create()
		local node, animMgr  = CCBuilderReaderLoad("gamedata/ccb/redtip.ccbi",proxy,{})
		redTips = tolua.cast(node,"CCLayer")
	elseif G_EQUIP_NEW == icoType then
		local  proxy = CCBProxy:create()
		local node, animMgr  = CCBuilderReaderLoad("gamedata/ccb/newtip.ccbi",proxy,{})
		redTips = tolua.cast(node,"CCLayer")
	else
		redTips = CCSprite:create()
		local pFrame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("redtip.png")
		redTips:setDisplayFrame(pFrame)
	end
	redTips:setTag(18)
	redTips:ignoreAnchorPointForPosition(true)
	node:addChild(redTips,999)
	local sz = node:getContentSize()
	offsetX = offsetX or 2/3
	offsetY = offsetY or 2/3
	redTips:setPosition(sz.width*offsetX,sz.height*offsetY)	
end

--移除红点
function removeRedtip(node)
	if node  and node:getChildByTag(18) ~= nil then 
		node:removeChildByTag(18,true)
	end
end

function haveRedtip(node)
	if node:getChildByTag(18) then
		return true
	end
	return false
end

--给文件加#括起来,用于改变字符串颜色
function bracket(str)
	return "#"..str .. "#"
end

--file
function exist(filename)
	local fullPath = CCFileUtils:sharedFileUtils():fullPathForFilename(filename)
	return CCFileUtils:sharedFileUtils():isFileExist(fullPath)
end


function rand(...)
    math.randomseed((os.clock()+math.random(5000,10000))*math.random(5000,10000))

    return math.random(...)
end

function RandomIndex(tabNum,indexNum)
    indexNum = indexNum or tabNum
    local t = {}
    local rt = {}
    for i = 1,indexNum do
        local ri = rand(1,tabNum + 1 - i)
        local v = ri
        for j = 1,tabNum do
            if not t[j] then
                ri = ri - 1
                if ri == 0 then
                    table.insert(rt,j)
                    t[j] = true
                end
            end
        end
    end
    return rt
end

function combTable(lhs,rhs)

	local ret = {}

	for index,value in pairs(lhs) do
		ret[index] = value
	end

	for index,value in pairs(rhs) do
		ret[index] = value
	end
	return ret	
end
--conv=require "conv"
g_doMadalLayer={}
function modalHandle(node,event)
	if event == "enter" then
		table.insert(g_doMadalLayer,node)
	elseif event == "exit" then
		for i,v in ipairs(g_doMadalLayer) do
			if v==node then
				table.remove(g_doMadalLayer,i)
				break
			end
		end
	end
end

function doModal(parent,child)
	parent=parent or CCDirector:sharedDirector():getRunningScene()
    local pModal=CCModalLayer:create()
	pModal:registerScriptHandler(function (event)
		return modalHandle(pModal,event)
	end)
    --全屏弹框
    local vsz=CCDirector:sharedDirector():getVisibleSize()
    pModal:setContentSize(vsz)
    local x=(vsz.width-960)/2
    local y=(vsz.height-640)/2
    child:setPosition(ccp(x,y))
    pModal:addChild(child)
    pModal:setTag(g_doModal_tag)
    pModal:setPosition(ccp(-x,-y))
    parent:addChild(pModal)
	pModal:setScale(1/parent:getScale())
    return pModal
end

function centerScene(scene,backFileName)
	local frameSize = CCEGLView:sharedOpenGLView():getFrameSize()
    scene:setAnchorPoint(ccp(0.5,0.5))
	--local scale = 1
	--if frameSize.width / frameSize.height < 960/640 then
	--	scale = frameSize.height/640
	--	scene:setScale(scale)
	--end
	
	local size = CCDirector:sharedDirector():getWinSize()
    scene:setPosition(ccp((size.width-960)/2, (size.height-640)/2))
	
    --[[if backFileName==nil then
        backFileName="gamedata/ui/back.png"
    end
    local bg=CCSprite:create(backFileName)
    if nil~=bg then
        bg:setAnchorPoint(ccp(0.5,0.5))
        local vsize = CCEGLView:sharedOpenGLView():getVisibleSize()
        bg:setPosition(ccp(vsize.width/2,vsize.height/2))
        scene:addChild(bg,-1)
    end]]
end

function pickStar()
    local w=rand(totalWeight)
    for i,v in ipairs(starWeight) do
        if w<=v.weight then
            return v.starId
        end
    end
    return nil
end

function isRepeatedStarId(sid,stars)
    for i,v in ipairs(stars) do
        if v.starId==sid then
            return true
        end
    end
    return false
end
	
function roundOff(fvalue)
	if nil==fvalue then
		return nil
	end
	local intV,floatV=math.modf(fvalue)
	if floatV>=0.5 then
		intV=intV+1
	end
	return intV
end

function copyTab(st)
    local tab = {}
    for k, v in pairs(st or {}) do
        if type(v) ~= "table" then
            tab[k] = v
        else
            tab[k] = copyTab(v)
        end
    end
    return tab
end

function tabIsEqual(t1,t2)
	if type(t1) ~= "table" or type(t2) ~= "table" then
		return false
	end
	if #t1~=#t2 then
		return false
	end
    for k, v in pairs(t1) do
        if type(v) ~= "table" then
			if t2[k] ~= v then
				return false
			end
            
        else
            if tabIsEqual(v,t2[k])==false then
				return false
			end
        end
    end
    return true
end
function tableSortByKey(t)
	local key_table = {}  
	--取出所有的键  
	for key,_ in pairs(t) do  
		table.insert(key_table,key)  
	end  
	--对所有键进行排序  
	table.sort(key_table)  
	local r={}
	for _,key in pairs(key_table) do  
		local tmp={}
		tmp.k=key
		tmp.v=t[key]
		table.insert(r,tmp)
	end 
	return r
end

--------------------------------------
-- Insert value of any type into array
--------------------------------------
local function arrayInsert( ary, val, idx )
    -- Needed because table.insert has issues
    -- An "array" is a table indexed by sequential
    -- positive integers (no empty slots)
    local lastUsed = #ary + 1
    local nextAvail = lastUsed + 1

    -- Determine correct index value
    local index = tonumber(idx) -- Don not use idx after this line!
    if (index == nil) or (index > nextAvail) then
        index = nextAvail
    elseif (index < 1) then
        index = 1
    end

    -- Insert the value
    if ary[index] == nil then
        ary[index] = val
    else
        -- TBD: Should we try to allow for skipped indices?
        for j = nextAvail,index,-1 do
            ary[j] = ary[j-1]
        end
        ary[index] = val
    end
end

--------------------------------
-- Compare two items of any type
--------------------------------
local function compareAnyTypes( op1, op2 ) -- Return the comparison result
    -- Inspired by http://lua-users.org/wiki/SortedIteration
    local type1, type2 = type(op1),     type(op2)
    local num1,  num2  = tonumber(op1), tonumber(op2)
    
    if ( num1 ~= nil) and (num2 ~= nil) then  -- Number or numeric string
        return  num1 < num2                     -- Numeric compare
    elseif type1 ~= type2 then                -- Different types
        return type1 < type2                    -- String compare of type name
    -- From here on, types are known to match (need only single compare)
    elseif type1 == "string"  then            -- Non-numeric string
        return op1 < op2                        -- Default compare
    elseif type1 == "boolean" then
        return op1                              -- No compare needed!
         -- Handled above: number, string, boolean
    else -- What s left:   function, table, thread, userdata
        return tostring(op1) < tostring(op2)  -- String representation
    end
end

-------------------------------------------
-- Iterate over a table in sorted key order
-------------------------------------------
local function pairsByKeys (tbl, func)
    -- Inspired by http://www.lua.org/pil/19.3.html
    -- and http://lua-users.org/wiki/SortedIteration

    if func == nil then
        func = compareAnyTypes
    end

    -- Build a sorted array of the keys from the passed table
    -- Use an insertion sort, since table.sort fails on non-numeric keys
    local ary = {}
    local lastUsed = 0
    for key --[[, val--]] in pairs(tbl) do
        if (lastUsed == 0) then
            ary[1] = key
        else
            local done = false
            for j=1,lastUsed do  -- Do an insertion sort
                if (func(key, ary[j]) == true) then
                    arrayInsert( ary, key, j )
                    done = true
                    break
                end
            end
            if (done == false) then
                ary[lastUsed + 1] = key
            end
        end
        lastUsed = lastUsed + 1
    end

    -- Define (and return) the iterator function
    local i = 0                -- iterator variable
    local iter = function ()   -- iterator function
        i = i + 1
        if ary[i] == nil then
            return nil
        else
            return ary[i], tbl[ary[i]]
        end
    end
    return iter
end

---------------------------------------------
-- Return indentation string for passed level
---------------------------------------------
local function tabs(i)
    return string.rep(".",i).." "   -- Dots followed by a space
end

-----------------------------------------------------------
-- Return string representation of parameter
-----------------------------------------------------------
local function toStrType(t)
    local function fttu2hex(t) -- Grab hex value from tostring() output
        local str = tostring(t)
        if str == nil then
            return "tostring() failure! \n"
        else
            local str2 = string.match(str,"[ :][ (](%x+)")
            if str2 == nil then
                return "string.match() failure: "..str.."\n"
            else
                return "0x"..str2
            end
        end
    end
    -- Stringify a value of a given type using a table of functions keyed
    -- by the name of the type (Lua's version of C's switch() statement).
    local stringify = {
        -- Keys are all possible strings that type() may return,
        -- per http://www.lua.org/manual/5.1/manual.html#pdf-type.
        ["nil"]			= function(v) return "nil (nil)"			    end,
        ["string"]		= function(v) return '"'..v..'" (string)'	    end,
        ["number"]		= function(v) return v.." (number)"			    end,
        ["boolean"]		= function(v) return tostring(v).." (boolean)"  end,
        ["function"]	= function(v) return fttu2hex(v).." (function)" end,
        ["table"]		= function(v) return fttu2hex(v).." (table)"	end,
        ["thread"]		= function(v) return fttu2hex(v).." (thread)"	end,
        ["userdata"]	= function(v) return fttu2hex(v).." (userdata)" end
    }
    return stringify[type(t)](t)
end

-------------------------------------
-- Count elements in the passed table
-------------------------------------
function lenTable(t)		-- What Lua builtin does this simple thing?
    local n=0                   -- '#' doesn't work with mixed key types
    if ("table" == type(t)) then
        for key in pairs(t) do  -- Just count 'em
            n = n + 1
        end
        return n
    else
        return nil
    end
end

--------------------------------
-- Pretty-print the passed table
--------------------------------
function do_dumptable(t, indent, seen)
    -- "seen" is an initially empty table used to track all tables
    -- that have been dumped so far.  No table is dumped twice.
    -- This also keeps the code from following self-referential loops,
    -- the need for which was found when first dumping "_G".
    
	if ("table" == type(t)) then	-- Dump passed table
        seen[t] = 1
        if (indent == 0) then
            print ("The passed table has "..lenTable(t).." entries:")
            indent = 1
        end
        for f,v in pairsByKeys(t) do
            if ("table" == type(v)) and (seen[v] == nil) then    -- Recurse
                print( tabs(indent)..toStrType(f).." has "..lenTable(v).." entries: {")
                do_dumptable(v, indent+1, seen)
                print( tabs(indent).."}" )
            else
                print( tabs(indent)..toStrType(f).." = "..toStrType(v))
            end
        end
    else
        print (tabs(indent).."Not a table!")
    end
	
end

--------------------------------
-- Wrapper to handle persistence
--------------------------------
function dumptable(t)   -- Only global declaration in the package
    -- This wrapper exists only to set the environment for the first run:
    -- The second param is the indentation level.
    -- The third param is the list of tables dumped during this call.
    -- Getting this list allocated and freed was a pain, and this
    -- wrapper was the best solution I came up with...
    --return do_dumptable(t, 0, {})
    --[[NOPRINT
	return do_dumptable(t, 0, {})
	]]
end

g_eventID=0
function getEventId()
	g_eventID=g_eventID+1
	return g_eventID
end

function closeMusic(val)

end

function exitGameDialogNew()

	if enterStbCode() then
		stb_popCloseList()
	end

	if isHuoSuSDK() then
					local tempData = {}
					tempData["key"] = 4
                	tempData["roleId"] = tostring(g_player_info.utid)
                   	tempData["roleName"] = g_player_info.name
                   	tempData["roleLevel"] = tostring(g_player_info.level)
                   	tempData["zoneId"] = tostring(g_svrId)
                   	tempData["zoneName"] = g_svrName
                   	tempData["balance"] = tostring(g_player_info.gold)
                   	tempData["vip"] = tostring(getPlayerVipLevel())
                   	tempData["partyName"] = "无帮派"
                   	tempData["roleCTime"] = ""
                   	tempData["roleLevelMTime"] = ""
            setSDKUserInfo(json.encode(tempData))
    end

	exitGameDialog()

end

require "gamedata/lua/coroutine_mgr"

function updateSvrTime()
	do return end
end

function Split(szFullString, szSeparator)  
	local nFindStartIndex = 1  
	local nSplitIndex = 1  
	local nSplitArray = {}  
	while true do  
	   local nFindLastIndex = string.find(szFullString, szSeparator, nFindStartIndex)  
	   if not nFindLastIndex then  
		nSplitArray[nSplitIndex] = string.sub(szFullString, nFindStartIndex, string.len(szFullString))  
		break  
	   end  
	   nSplitArray[nSplitIndex] = string.sub(szFullString, nFindStartIndex, nFindLastIndex - 1)  
	   nFindStartIndex = nFindLastIndex + string.len(szSeparator)  
	   nSplitIndex = nSplitIndex + 1  
	end  
	return nSplitArray  
end

--为掉落添加log
function dropLog(drop,isSell)
	if type(drop)~= "table" then 
		return 
	end
	if _G.next(drop) == nil then return end
	table.foreach(drop,function (k,v)
		if not v.id then return end
		local firstLetter=string.sub(v.id,1,1)
		if firstLetter=="E" then--装备
			if v.isFragment then--碎片
				local log = battleLog(ls('获得 ')..bracket(configEquips[v.id].name..ls('碎片')).."x"..v.num)
				log:setColorByIndex(2,GCOLOR.X)
			else--整个装备的掉落
				for n=1,v.num do
					local desc
					if isSell or v.status == SELLED then
						desc = ls('获得 ')..bracket(configEquips[v.id].name.."Lv."..v.level)
						desc = desc .. bracket(ls('(自动卖出)'))
						local log = battleLog(desc)
						log:setColorByIndex(2,GCOLOR[v.grade])
						log:setColorByIndex(3,GCOLOR["C"])
					elseif v.status == PUTAWAY then
						desc = ls('获得 ')..bracket(configEquips[v.id].name.."Lv."..v.level)
						desc = desc .. bracket(ls('(包裹满丢弃)'))
						local log = battleLog(desc)
						log:setColorByIndex(2,GCOLOR[v.grade])
						log:setColorByIndex(3,GCOLOR["C"])
					else
						desc = ls('获得 ')..bracket(configEquips[v.id].name.."Lv."..v.ei[n].mLevel)
						local log = battleLog(desc)
						log:setColorByIndex(2,GCOLOR[v.ei[n].mGrade])
					end
				end
			end
		elseif firstLetter=="B" or firstLetter == "F" then--书籍阵法
			local configList
			if firstLetter=="F" then
				configList=configFormations
			else
				configList=configBooks
			end
			if not v.isFragment then--直接整个掉落
				for n=1,v.num do
					local log = battleLog(ls('获得 ')..bracket(configList[v.id].name))
					log:setColorByIndex(2,GCOLOR[configList[v.id].grade])
				end
			else--碎片
				local log = battleLog(ls('获得 ')..bracket(configList[v.id].name.. ls(' 碎片')).."x"..v.num)
				log:setColorByIndex(2,GCOLOR[configList[v.id].grade])
			end
		elseif firstLetter=="I" then--物品
			local log = battleLog(ls('获得 ')..bracket(configItems[v.id].name))
			log:setColorByIndex(2,GCOLOR[configItems[v.id].grade])
		elseif firstLetter=="H" then--魂
			local log = battleLog(ls('获得 ')..bracket(configHeroes[v.id].name..ls('魂')).."x"..v.num)
			log:setColorByIndex(2,GCOLOR[configHeroes[v.id].grade])
		end
	end)
end

------------------------------------
-- 英雄是否可合成
------------------------------------
function canCompose(heroId,countH) 
	--是否存在此英雄
	for _,v in pairs(g_hero_list) do
		if v.mHeroId == heroId then
			return false
		end
	end
	local soulNum = configHeroes[heroId]["hireSouls"]
	if countH >= soulNum then
		return true
	end
	return false
end

------------------------------------
-- 英雄是否可进阶
------------------------------------
function canAdvance(heroId,countH)
	--是否存在此英雄
	local heroIndex = nil
	for _,v in pairs(g_hero_list) do
		if v.mHeroId == heroId then
			heroIndex = v
			break
		end
	end
	if not heroIndex then
		return false
	end
	
	if heroIndex.mTupo < G_MAXTUPO then
		local gd=configHeroes[heroIndex.mHeroId]["grade"]
		local needCount=configEvolution[gd]["evolutionSoul"][heroIndex.mTupo+1]
		if countH >= needCount then
			return true
		end
	end
	return false
end

--把服务器发回来的掉落信息转换为本地的数据
function dropDecode(drop,needLog)
	local dropCount = {}
	dropCount.equip = {}
	dropCount.equip["A"]=0
	dropCount.equip["B"]=0
	dropCount.equip["C"]=0
	dropCount.equip["D"]=0
	dropCount.equip["X"]=0
	dropCount.equip["S"]=0
	dropCount.formation = {}
	dropCount.formation["A"]=0
	dropCount.formation["B"]=0
	dropCount.formation["C"]=0
	dropCount.formation["D"]=0
	dropCount.formation["S"]=0
	dropCount.goods = {}
	dropCount.soul = {}
	dropCount.soul["A"]=0
	dropCount.soul["B"]=0
	dropCount.soul["C"]=0
	dropCount.soul["D"]=0
	if type(drop)~= "table" then 
		return dropCount
	end
 	if _G.next(drop) ==nil then return dropCount end
	if needLog then
		dropLog(drop)
	end
	
	table.foreach(drop,function (k,v)
		if not v.id then return end
		local firstLetter=string.sub(v.id,1,1)
		if firstLetter=="E" then--装备
			if v.isFragment then--碎片
				local isFind=false
				for j, vv in ipairs(g_equipFragment_list) do
					if vv.id==v.id then
						isFind=true
						vv.count=vv.count+v.num
						if vv.count >= G_FRAGMENT_COMPOSE then
							g_localPlayer.equipCompose = true
						end
						break
					end
				end
				if not isFind then
					local t={}
					t.id=v.id
					t.count=v.num
					table.insert(g_equipFragment_list,t)
				end
			elseif not v.status then--整个装备的掉落
				for n=1,v.num do
					local newEquip = EquipInfo:create(v.ei[n])
					if newEquip.mGrade == "X" then
						g_player_info.cj_shenqiCnt = g_player_info.cj_shenqiCnt + 1
					end
					table.insert(g_equip_list,newEquip)
					dropCount.equip[v.ei[n].mGrade] = dropCount.equip[v.ei[n].mGrade] + 1
					local replaceList = isNewbilityEquip(newEquip)
					if #replaceList > 0 then
						addRedtip(GameMainScene.navHero,G_EQUIP_NEW)
						for _,pos in pairs(replaceList) do
							g_buzhen_list[pos].newEquip = g_buzhen_list[pos].newEquip or {}
							g_buzhen_list[pos].newEquip[newEquip.mSubType] = true
						end
					end
				end
				--saveJsonEquip()
			end
		elseif firstLetter=="B" or firstLetter == "F" then--书籍阵法
			local configList
			if firstLetter=="F" then
				configList=configFormations
			else
				configList=configBooks
			end
			if not v.isFragment then--直接整个掉落
				for n=1,v.num do
					if firstLetter=="F" then
						table.insert(g_form_list,createForm(v.idCnt[n],v.id))
						--dropCount.formation[configFormations[v.id].grade] = dropCount.formation[configFormations[v.id].grade] +1
						--saveJsonFormations()
					else
						table.insert(g_skill_list,SkillInfo:create(v.idCnt[n],v.id))
						--saveJsonSkill()
					end
				end
			else--碎片
				if firstLetter=="F" then
					addFormFragment(v)
				else
				end
				
				--saveJsonItem()
			end
		elseif firstLetter=="I" then--物品
			local isExsit=false
			for j,vv in ipairs(g_goods_list) do
				if vv.id==v.id then
					isExsit=true
					vv.count=vv.count+v.num
				end
			end
			if not isExsit then
				local t=GoodsInfo:create(v.id,v.num)
				table.insert(g_goods_list,t)
			end
			dropCount.goods[v.id] = dropCount.goods[v.id] or 0
			dropCount.goods[v.id] = dropCount.goods[v.id] + v.num
			--saveJsonGoods()
			if v.id=="IE014" then
				postNotification("updateMysticalFreeCnt")
			end
		elseif firstLetter=="H" then--魂
			local isFind=false
			local countH = 0
			for n,vv in ipairs(g_soul_list) do
				if v.id==vv.mHeroId then
					vv.mCount=vv.mCount+v.num
					countH = vv.mCount
					isFind=true
					break
				end
			end
			if not isFind then
				local t={}
				t.mCount=v.num
				countH = v.num
				t.mHeroId=v.id
				table.insert(g_soul_list,t)
			end
			--saveJsonSoul()
			dropCount.soul[configHeroes[v.id].grade] = dropCount.soul[configHeroes[v.id].grade] + 1
			--如果可合成或进阶
			if canCompose(v.id,countH) or canAdvance(v.id,countH) then
				addRedtip(GameMainScene.navHero)
				addRedtip(GameMainScene.heroList.btnSoul)
			end
		elseif string.sub(v.id,1,2)=="cw" then
			addPetFragmentCnt(v)
		end
	end)
	return dropCount
end

--奖励等非掉落的，直接通过些加入列表
function addEquip(v)
	if type(v)~= "table" then 
		return 
	end
	if not v.id then return end
	local firstLetter=string.sub(v.id,1,1)
	if firstLetter=="E" then--装备
		if v.isFragment then--碎片
			local isFind=false
			for j, vv in ipairs(g_equipFragment_list) do
				if vv.id==v.id then
					isFind=true
					vv.count=vv.count+v.num
					break
				end
			end
			if not isFind then
				local t={}
				t.id=v.id
				t.count=v.num
				table.insert(g_equipFragment_list,t)
			end
		else--整个装备的掉落
			for n=1,v.num do
				table.insert(g_equip_list,EquipInfo:create(v.ei[n]))
			end
			--saveJsonEquip()
		end
	elseif firstLetter=="B" or firstLetter == "F" then--书籍阵法
		local configList
		if firstLetter=="F" then
			configList=configFormations
		else
			configList=configBooks
		end
		if not v.isFragment then--直接整个掉落
			for n=1,v.num do
				if firstLetter=="F" then
					table.insert(g_Formations_list,generatFormationNew(v.idCnt[n],v.id))
					--saveJsonFormations()
				else
					table.insert(g_skill_list,SkillInfo:create(v.idCnt[n],v.id))
					--saveJsonSkill()
				end
			end
		else--碎片
			addFragmentInfo(v)
			--saveJsonItem()
		end
	elseif firstLetter=="I" then--物品
		local isExsit=false
		for j,vv in ipairs(g_goods_list) do
			if vv.id==v.id then
				isExsit=true
				vv.count=vv.count+v.num
			end
		end
		if not isExsit then
			local t=GoodsInfo:create(v.id,v.num)
			table.insert(g_goods_list,t)
		end
		--saveJsonGoods()
	elseif firstLetter=="H" then--魂
		local isFind=false
		for n,vv in ipairs(g_soul_list) do
			if v.id==vv.mHeroId then
				vv.mCount=vv.mCount+v.num
				isFind=true
				break
			end
		end
		if not isFind then
			local t={}
			t.mCount=v.num
			t.mHeroId=v.id
			table.insert(g_soul_list,t)
		end
		--saveJsonSoul()
	
	end
end


function getUsableBoxCnt(grade)--A 金宝箱 B 银宝箱 C 铜宝箱
	local keyC=0
	local boxC=0
	local keyId=""
	local boxId=""
	for i,v in ipairs(g_goods_list) do
		if configItems[v.id].grade==grade then 
			if configItems[v.id].type=="box" then
				boxC=v.count
				boxId=v.id
			elseif configItems[v.id].type=="key" then
				keyC=v.count
				keyId=v.id
			end
		end
		if keyC>0 and boxC>0 then
			break
		end
	end
	return math.min(keyC,boxC),keyId,boxId
end
function getFntFileByHI(hi)
	if hi.orangeLv and hi.orangeLv>0 and not configOrangeInfo[hi.orangeLv+1] then
		return "gamedata/font/loliS24.fnt"
	else
		return "gamedata/font/loli"..configHeroes[hi.mHeroId]["grade"].."24.fnt"
	end
end
function getGradeByHI(hi)
	if hi.orangeLv and hi.orangeLv>0 and not configOrangeInfo[hi.orangeLv+1] then
		return "S"
	else
		return configHeroes[hi.mHeroId]["grade"]
	end
end
function getInfoFromDrop(drop)
	local id=drop.id
	if id=="gold" then
		return "IEgold.png",ls('元宝'),"gamedata/font/loliA24.fnt","A",ls('土豪们的最爱，高富帅的象征，白富美的追求，屌丝们的梦想。')	elseif id=="coin" then
		return "IEcoin.png",ls('银币'),"gamedata/font/loliD24.fnt","D",ls('游戏里的通用货币，各种地方都用的到，多多收集，绝对有利。')	end
	local isFragment=drop.isFragment
	local suipianPos=drop.suipianPos or 0
	local first=string.sub(id,1,1)
	local assetId=""
	local name=""
	local gd = drop.grade
	if gd=="X" then 
		--gd="S"
	end
	local desc=""
	local fnt=""
	if first=="E" then--装备
		assetId=configEquips[id]["assetId"]..".png"
		name=configEquips[id]["name"]
		desc=configEquips[id].desc
		local fntGd=gd
		if fntGd==nil then
			fntGd="X"
			gd="X"
		end
		fnt="gamedata/font/loli"..fntGd.."24.fnt"
		if CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName(assetId)==nil then
			local subType=configEquips[id].subtype
			if "weapon"==subType then
				assetId="EA101.png"
			elseif "headdress"==subType then
				assetId="EA200.png"
			elseif "accessory"==subType then
				assetId="EC501.png"
			elseif "shoes"==subType then
				assetId="EC300.png"
			else --dress
				assetId="EA401.png"
			end
			
		end
	elseif first=="B" then--书
		assetId=configBooks[id]["assetId"]
		--CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("gamedata/ui/"..assetId..".plist","gamedata/ui/"..assetId..".png")
		assetId=configBooks[id]["assetId"]..".png"
		name=configBooks[id]["name"]
		gd=configBooks[id].grade
		desc=configBooks[id].desc
		if CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName(assetId)==nil then
			assetId="icon_book_sunzi.png"
		end
		fnt="gamedata/font/loli"..configBooks[id].grade.."24.fnt"
	elseif first=="S" then--天赋技能
		assetId=configSkills[id]["assetId"]
		---CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("gamedata/ui/"..assetId..".plist","gamedata/ui/"..assetId..".png")
		assetId=configSkills[id]["assetId"]..".png"
		name=configSkills[id]["name"]
		gd=configSkills[id].grade
		desc=configSkills[id].desc
		if CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName(assetId)==nil then
			assetId="gicon.png"
		end
		fnt="gamedata/font/loli"..configSkills[id].grade.."24.fnt"
	elseif first=="F" then--阵法
		assetId=configFormations[id]["assetId"]..".png"
		name=configFormations[id]["name"]
		gd=configFormations[id].grade
		desc=configFormations[id].desc
		fnt="gamedata/font/loli"..configFormations[id].grade.."24.fnt"
	elseif first=="I" then--物品
		assetId=configItems[id]["assetId"]..".png"
		if CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName(assetId)==nil then
			assetId="IE012.png"
		end
		name=configItems[id]["name"]
		gd=configItems[id].grade
		desc=configItems[id].desc
		fnt="gamedata/font/loli"..gd .."24.fnt"
	elseif first=="H" then--武将魂
		--assetId=configHeroes[id]["assetId"]
		--CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("gamedata/hero/"..assetId..".plist","gamedata/hero/"..assetId..".png")
		assetId="head_"..configHeroes[id]["assetId"]..".png"
		if CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName(assetId)==nil then
			assetId="head_HA999.png"
		end
		if id=="HC900" then
			name=configHeroes[id]["name"]
		else
		name=configHeroes[id]["name"]..ls('魂')		end
		gd=configHeroes[id].grade
		desc=configHeroes[id].desc
		fnt="gamedata/font/loli"..configHeroes[id].grade.."24.fnt"
	elseif string.sub(id,1,4)=="sclb" then--礼包
		assetId=configShopPackage[id]["assetid"]..".png"
		name=configShopPackage[id]["name"]
		gd=configShopPackage[id].grade or "S"
		desc=configShopPackage[id].desc
		fnt="gamedata/font/loli"..gd.."24.fnt"
			elseif string.sub(id,1,2)=="cw" then--宠物
		assetId="head_"..configPet[id].assetid..".png"
		name=configPet[id].name
		desc=configPet[id].desc
		gd="A"
		fnt="gamedata/font/loli"..gd.."24.fnt"
	elseif string.sub(id,1,3)=="CWS" then--宠物技能
		assetId=configPetSkills[id].assetId..".png"
		name=configPetSkills[id].name
		desc=configPetSkills[id].desc
		gd=configPetSkills[id].grade
		fnt="gamedata/font/loli"..gd.."24.fnt"
	end
	if first~="H" and isFragment then
		if true ~= g_isEnglish then
			name=name..ls('碎片')
		end
		if suipianPos>0 then
			local zf={}
			zf[1]=ls('一')
			zf[2]=ls('二')
			zf[3]=ls('三')
			zf[4]=ls('四')
			zf[5]=ls('五')
			zf[6]=ls('六')
			name=name..zf[suipianPos]
		end
	end
	return assetId,name,fnt,gd,desc
end

function getDayTime( time )--返回今天0点的时间
    local t=os.date("*t",time)
    t.hour=0
    t.min=0
    t.sec=0
    return os.time(t)
end

function getDayActionLimit(tb)

	local dayStr = getDayStr(os.time())
	local toDayLimit = tb[dayStr]

	return toDayLimit

end

isFakeUser = isFakeUser or function()

	return false

end

function getFakeUserLevel()

	local level = g_player_info.level

	return level

end

function actionLimitUpdate(ret,callback)

	if not ret.actionPair then
		return
	end

	if ret.actionPair.name then
		return actionLimitUpdateImpl(ret,callback)
	end

	if type(ret.actionPair) == "table" then
		for index,value in ipairs(ret.actionPair) do
			actionLimitUpdateImpl2(value,callback)
		end
	end

end


function actionLimitUpdateImpl2(actionPair,callback)

	if g_player_info.enableActionLimit and actionPair.name then

		local dayStr = getDayStr(os.time())

		if g_player_info.actLimit[dayStr] ~= nil then --防止凌晨

			g_player_info.actLimit[dayStr][actionPair.name] = actionPair.value

			if callback then
				callback()
			end

		end

	end

end

function actionLimitUpdateImpl(ret,callback)

	if ret and ret.actionPair then
		return actionLimitUpdateImpl2(ret.actionPair,callback)
	end

end

--把长达几天的日期转换成小时
function hourStr(gap)

	local ret = ls('%02d:%02d:%02d',math.floor(gap/3600),math.floor(gap/60)%60,gap%60)
	return ret
end

function addNodeFragment(layer,size)

	local tex = CCSprite:create()
	local fragIcon = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("equip_fragment.png")

	--左上角
	tex:setDisplayFrame(fragIcon)

	if not size then
		local rsize = layer:getContentSize()
		size = CCSize(rsize.width*layer:getScaleX(),rsize.height*layer:getScaleY())
	end

	local texSize = tex:getContentSize()
	tex:setTag(328)
	layer:addChild(tex)

	tex:setPosition(ccp(size.width+texSize.width,size.height+texSize.height))
end

function removeNodeFragment(node)

	local child = node:getChildByTag(328)
	if child then
		child:removeFromParentAndCleanup(true)
	end

end

function getDayStr( time )--默认返回今天的日期年月日
    local t=time or os.time()
    return os.date("%Y-%m-%d", t)
end

function getYesterdayStr(  )
    return getDayStr(os.time()-86400)
end

function getTimeStr( time )
    local t=time or os.time()
    return os.date("%Y-%m-%d %X", t)
end
function str2Time( str )
    local s,e,year,month,day,hour,min,sec=string.find(str,"(%d+)%D(%d+)%D(%d+)%D(%d+)%D(%d+)%D(%d+)")
    if s and e then 
        return os.time({year=tonumber(year),month=tonumber(month),day=tonumber(day),hour=tonumber(hour),min=tonumber(min),sec=tonumber(sec)})
    else 
        return 0
    end
end
--获取公会等级，下一级，及升级所需的建设度,当前lv经验
function getGuildLevel(exp)
	for i,v in ipairs(configGuild) do
		if exp<v.buildValue then
			return i-1,i,v.buildValue,exp
		else
			exp=exp-v.buildValue
		end
	end
	return #configGuild,#configGuild,configGuild[#configGuild].buildValue,exp
end

--获取公会可允许的总人数，普通成员，精英，副会长，会长人数
function getGuildMemCnt( exp )
	local lv=#configGuild
	for i,v in ipairs(configGuild) do
		if exp<v.buildValue then
			lv=i-1
			break
			--return v.playNumber,v.memberNumber,v.eliteNumber,v.viceChairmanNumber
		else
			exp=exp-v.buildValue
		end
	end
	local v=configGuild[lv]
	return v.playNumber,v.memberNumber,v.eliteNumber,v.viceChairmanNumber
end

function getVipLevel(chargedGold)
	local rate = 10 * g_chongzhiMulti
	chargedGold=chargedGold or 0
	for i,v in ipairs(configVip) do
		if chargedGold< v.money*rate then
			return i-2,i-1,v.money*rate
		end
	end
	return #configVip-1,#configVip-1,configVip[#configVip].money*rate
end

function getPlayerVipLevel()
	local rate = 10 * g_chongzhiMulti
	g_player_info.chargedGold=g_player_info.chargedGold or 0
	for i,v in ipairs(configVip) do
		if g_player_info.chargedGold< v.money*rate then
			return i-2,i-1,v.money*rate
		end
	end
	return #configVip-1,#configVip-1,configVip[#configVip].money*rate
end

function getItemLimitCnt(itemId)
	local vipLevel=getPlayerVipLevel()
	for k,v in pairs(configVip[vipLevel+1].buyNumber) do
		if v==itemId then 
			return configVip[vipLevel+1].buyNumber[k.."Limit"]
		end
	end
	return nil
end

function splitByChar(str,split)
	local strTmp=str
	local s,e
	local t={}
	s,e=string.find(strTmp,split)
	while s do
		if s>1 then
			table.insert(t,string.sub(strTmp,1,s-1))
		end
		strTmp=string.sub(strTmp,e+1)
		s,e=string.find(strTmp,split)
	end
	if strTmp~="" then
		table.insert(t,strTmp)
	end
	return t
end

function moneyTrans(money)
	local sw=money
	if true == g_isEnglish then
		if sw<1000 then 
			return sw
		elseif sw<1000000 then 
			sw=math.floor(sw/1000) .. ls('K')
		else
			local tmp = math.floor(sw/1000000) .. ls('M')
			if math.floor((sw%1000000)/1000) ~= 0 then
				tmp = tmp .. math.floor((sw%1000000)/1000) .. ls('K')
			end
			sw = tmp
		end
	else
		if sw>=1000000 then 
			sw=math.floor(sw/10000) .. ls('万')
		end
	end
	return sw
end

function decimalPoint2(number)
	return roundOff(number*100)/100
end

function simplifyStr(srcStr,cnt)
	local index = 1 
	local rowIndex = 1 --字符指针
	local count = 0
	local desStr = ""
	while index <= string.len(srcStr) do
		local firstCase = string.byte(srcStr,index) 
		
		if firstCase == nil then
			break
		end
		local caseLen = sizeof(firstCase)	--字符宽度
		local secondCase=string.byte(srcStr,index+caseLen) 
		local secondCaseLen=0
		if secondCase~=nil then
			secondCaseLen=sizeof(secondCase)
		end
		index = index + caseLen
		if caseLen==1 then
			count = count + 0.5
		else
			count = count + 1
		end
		if desStr=="" and count>=cnt-2 then
			desStr=string.sub(srcStr,1,index-1).."..."
		end
	end
	if count>cnt then
		return desStr
	end
	return srcStr
end

function getTypeStr(id)
	local firstZM=string.sub(id,1,1)
	if firstZM=="I" then
		return ls('道具')	elseif firstZM=="E" then--装备
		return configStrings[configEquips[id].subtype]
	elseif firstZM=="B" then--书籍
		return ls('书籍')	elseif firstZM=="H" then--武将
		return ls('武将')	end
	return ls('道具')end

function getHeroSprite(heroid)
	local sprite = CCSprite:create("gamedata/hero/"..jsonHero[heroid]["assetId"]..".png")
	if nil == sprite then
		sprite = CCSprite:create("gamedata/hero/HA999.png")
	end
	return sprite
end

function removeTexture(texture)
	CCTextureCache:sharedTextureCache():removeTexture(texture)
end

function getHeroPic(heroid,extr)
	extr=extr or ""
	local assetId=heroid
	if type(heroid)=="table" then
		if false and heroid.guanLv>=5 then--五品变颜色
			assetId=configHeroGuanJie[heroid.mHeroId].assetId
		else
			assetId=configHeroes[heroid.mHeroId].assetId
		end
	else
		if configHeroes[heroid] then
			assetId = configHeroes[heroid]["assetId"]
		else
			assetId = heroid
		end
	end
	local defaultFormat=CCTexture2D:defaultAlphaPixelFormat()
	CCTexture2D:setDefaultAlphaPixelFormat(kCCTexture2DPixelFormat_RGBA4444)
	local picName = "gamedata/hero/" .. extr .. assetId ..".png"
    local pTexture = CCTextureCache:sharedTextureCache():addImage(picName)
    if nil == pTexture then
		picName = "gamedata/hero/HA999.png"
		pTexture = CCTextureCache:sharedTextureCache():addImage(picName)
	end
	CCTexture2D:setDefaultAlphaPixelFormat(defaultFormat)
	if nil == pTexture then
		return nil
	end
	local rect = pTexture:getContentSize()
	local pFrame = CCSpriteFrame:create(picName,CCRectMake(0,0,rect.width,rect.height))
	return pFrame
end

function removeHeroPic(heroid)
	local picName = "gamedata/hero/"..configHeroes[heroid]["assetId"]..".png"
	CCTextureCache:sharedTextureCache():removeTextureForKey(picName)
end

function getHeroHeadPic(heroid)
	local frmName = "head_"..jsonHero[heroid]["assetId"]..".png"
	local pFrame = 	CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName(frmName)
	if nil==pFrame then
		pFrame = 	CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("head_HA999.png")
	end
	return pFrame
end

function getHeroHeadPicByHi(lghero)
	local assetId=jsonHero[lghero.mHeroId].assetId
	if lghero.curSkin and configSkinAttr[lghero.curSkin] then
		assetId=configSkinAttr[lghero.curSkin].assetId
	end
	local frmName = "head_"..assetId..".png"
	local pFrame = 	CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName(frmName)
	if nil==pFrame then
		pFrame = 	CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("head_HA999.png")
	end
	return pFrame
end

function getHeroSoulCount(heroid)
	for i = 1,#g_soul_list do
		if g_soul_list[i].mHeroId == heroid then
			return g_soul_list[i].mCount
		end
	end
	return 0
end

function getEnemyHeadPic(enemyId)
	local frmName 
	local pFrame
	if enemyId ~= "" then
		frmName = "head_"..enemyId..".png"--configEnemys[enemyId]["assetId"]..".png"
		pFrame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName(frmName)
	end
	if nil==pFrame then
		pFrame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("head_HA999.png")
	end
	return pFrame
end

function getAssetHeadPic(id)
	local frmName 
	local pFrame =  CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("head_"..id..".png")
	if nil==pFrame then
		pFrame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("head_HA999.png")
	end
	return pFrame
end

function getRoleHeadPic(role)
	local pFrame = nil
	if role == 1 then
		pFrame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("start_man1.png")
	elseif role == 2 then
		pFrame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("start_woman1.png")
	elseif role == 3 then
		pFrame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("start_man2.png")
	elseif role == 4 then
		pFrame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("start_woman2.png")
    elseif role == 5 then
		pFrame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("start_man3.png")
    elseif role == 6 then
		pFrame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("start_woman3.png")
	end
	return pFrame
end

function getRoleHeadIcon(role)
	local pFrame = nil
	if role == 1 then
		pFrame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("icon_frame_man1.png")
	elseif role == 2 then
		pFrame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("icon_frame_woman1.png")
	elseif role == 3 then
		pFrame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("icon_frame_man2.png")
	elseif role == 4 then
		pFrame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("icon_frame_woman2.png")
	elseif role == 5 then
		pFrame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("icon_frame_man3.png")
    elseif role == 6 then
		pFrame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("icon_frame_woman3.png")
	end
	return pFrame
end

--用来设置装备的强化等级。如果没有强化，隐藏之
function setUpgradeLevel( item, upgradeLevel )
	if 0 == upgradeLevel or nil == upgradeLevel then
		item:setVisible(false)
	else
		item:setString("+"..upgradeLevel)
		item:setVisible(true)
	end
end


----------只给战斗用---------------
local _holdrand = 1
function exSrand(seed)
    _holdrand = tonumber(seed)
end

function getRandSeed( )
    return _holdrand
end

--C rand()
function exRand()
    _holdrand = (_holdrand * 214013 + 2531011)%4294967296
    return math.floor(_holdrand/65536)%32768
end

function isChanceHit(chance)
    --return (exRand() %10000) < chance * 10000
    return exRand() < chance * 32768
end


local rndgen = {}

function rndgen.nextround(self)
    self.round = self.round + 1
    if self.round >= self.max_round then
        self.round = 0
        --self.hit_round = exRand() % self.max_round
    end
end

function rndgen.ishit(self)
    if self.round== self.hit_round then
        self:nextround()
        return true
    end
    self:nextround()

    local a = 1 / self.max_round
    local extra_hit = isChanceHit( (self.probability - a)/(1 - a))
    return extra_hit
end

function createRandGenerator(probability)
    if probability>1 then probability = 1 end
    if probability<0 then
        probability = 0.00000001
    end	
    local max_round = math.ceil(1 / probability)
    local max_round2 = math.ceil(1 / (probability+0.01))
    if max_round2 ~= max_round then
        max_round = max_round2
    end
    local hit_round = exRand() % max_round
    return setmetatable({probability = probability,hit_round = hit_round, max_round = max_round,round = 0},{__index = rndgen})
end

----------只给战斗统计用---------------
local _holdrand_00 = 1
function exSrand_00(seed)
    _holdrand_00 = tonumber(seed)
end

function getRandSeed_00( )
    return _holdrand_00
end

--C rand()
function exRand_00()
    _holdrand_00 = (_holdrand_00 * 214013 + 2531011)%4294967296
    return math.floor(_holdrand_00/65536)%32768
end

--是否可以吃包子
function canEat()
	local eat = false
	local t = os.date("*t",os.time())
	local hour = t.hour
	if hour>=12 and hour <=13 then
		if not g_player_info.noonBun then
			eat=true
		end
	elseif hour>=18 and hour <=19 then
		if not g_player_info.midBun then
			eat=true
		end
	elseif hour>=21 and hour <=22 then
		if not g_player_info.nightBun then
			eat=true
		end
	end
	return eat
end

--是否有未领取的封测礼包
function haveFCGift()
	if g_isInFengCe and g_player_info.fcGiftIndex and g_player_info.fcGiftIndex<15 and g_player_info.fcGiftDay~=getDayStr() then
		return true
	end
	return false
end
--是否有未领礼包
function haveLvGift()
	for i=1,g_player_info.level do
		if configLvGift[tostring(i)] and not g_player_info.lvGift[tostring(i)] then
			return true
		end
	end
	return false
end

--是否有成长计划可领取
function haveGrowPlanGift()
	if g_player_info.growPlan.bought then
		for i,v in ipairs(configGrowthPlan) do
			if v.level<=g_player_info.level and not g_player_info.growPlan[i] then
				return true
			end
		end
	end
	return false
end

--是否有免费祈福武将
function haveFreePrayHero()
	return g_player_info.prayHero.cnt==0
end

--是否有vip礼包可领
function haveVipGift()
	local vl=getPlayerVipLevel()
	if vl>0 then
		if g_player_info.vipGiftDay~=getDayStr(os.time()) then
			return true
		end
	end
	return false
end

--是否有好评送礼可领
function haveCommentGift()
	local curTime=os.time()
	if g_player_info.commentGift == nil then
		return 0
	elseif curTime - g_player_info.commentGift.time < 10 then
		return 1
	elseif g_player_info.commentGift.get == false then
		return 2
	else
		return 3
	end
end

--是否有聚宝盆活动
function haveJBP()
	if g_localPlayer.JBP_look then--查看过一次，以后都不在红点提示
		return false
	end
	for i,v in ipairs(g_activity_now) do
		if v.ty==1 then
			local start=str2Time(v.s)
			local time=os.time()
			if time>start and time<start+v.t then
				return true
			end
		end
	end
	return false
end

--是否有限时神将活动
function haveLimitHero()
	--if g_localPlayer.limitHero_look then--查看过一次，以后都不在红点提示
	--	return false
	--end
	for i,v in ipairs(g_activity_now) do
		if v.ty==2 then
			local start=str2Time(v.s)
			local time=os.time()
			if time>start and time<start+v.t then
				if g_localPlayer.limitHero_look~=v.s then
					return true
				else
					return false
				end
				--return true
			elseif type(v.h)=="table" then--四选一
				if time>start+v.t then--活动结束可领取
					if g_localPlayer.limitHero_look2~=v.s then--没在结束后查看过的都给个红点提示
						return true
					end
				end
			end
		end
	end
	return false
end
local firstMoney=100
local secondMoney=300
if getSDKName()=="huanyi_app" then
	firstMoney=200
	secondMoney=400
end
--是否有新武将活动
function haveNewHero()
	--先查看是否有没领取的
	for i,v in ipairs(g_activity_now) do
		if v.ty==3 then
			local start=str2Time(v.s)
			local time=os.time()
			if start<=time and start+v.t>time - 86400 then
				if g_activity.NH and g_activity.NH[v.s] then
					if g_activity.NH[v.s].v>=firstMoney and not g_activity.NH[v.s].h1 then
						return true
					end
					if v.heroId2~="" and g_activity.NH[v.s].v>=secondMoney and not g_activity.NH[v.s].h2 then
						return true
					end
				end
			end
		end
	end
	
	if g_localPlayer.newHero_look then--查看过一次，以后都不在红点提示
		return false
	end
	for i,v in ipairs(g_activity_now) do
		if v.ty==3 then
			local start=str2Time(v.s)
			local time=os.time()
			if time>start and time<start+v.t then
				return true
			end
		end
	end
	return false
end

--是否有累计充值活动
function haveConsumTotal()
	--先查看是否有没领取的
	for i,v in ipairs(g_activity_now) do
		if v.ty==8 then
			local start=str2Time(v.s)
			local time=os.time()
			if start<=time and start+v.t>time - 86400 then
				if g_activity.CT and g_activity.CT[v.s] then
					if not g_activity.CT[v.s].yet then
						g_activity.CT[v.s].yet={}
					end
					
					for ii,vv in ipairs(v.info) do
						if vv.gold<=g_activity.CT[v.s].v and not g_activity.CT[v.s].yet[ii] then
							return true
						end
					end
				end
			end
		end
	end
	
	if g_localPlayer.consumTotal_look then--查看过一次，以后都不在红点提示
		return false
	end
	for i,v in ipairs(g_activity_now) do
		if v.ty==8 then
			local start=str2Time(v.s)
			local time=os.time()
			if time>start and time<start+v.t then
				return true
			end
		end
	end
	return false
end

chargeTotalTy = 42

--是否有累计充值活动
function haveChargeTotal()
	--先查看是否有没领取的
	for i,v in ipairs(g_activity_now) do
		if v.ty==chargeTotalTy then
			local start=str2Time(v.s)
			local time=os.time()
			if start<=time and start+v.t>time then
				if g_activity.CHT and g_activity.CHT[v.s] then
					
					for ii,vv in ipairs(v.info) do

						if g_activity.CHT[v.s][ii] and g_activity.CHT[v.s][ii].gotAble then
							postNotification("leijiNew2")
							return true
						end

					end

				end
			end
		end
	end
	
	if g_localPlayer.chargeTotal_look then--查看过一次，以后都不在红点提示
		return false
	end
	for i,v in ipairs(g_activity_now) do
		if v.ty==chargeTotalTy then
			local start=str2Time(v.s)
			local time=os.time()
			if time>start and time<start+v.t then
				postNotification("leijiNew2")
			end
		end
	end
	return false
end

--是否有每日充值活动
function haveChargeDaily()
	--先查看是否有没领取的
	local time=os.time()
	local today=getDayStr(time)
	
	--临时修正方案
	if nil == configChargeDaily then
		local path = getTmpPath() .. "/gamedata/config/testdailyrecharge.json"
		len = 0
		fileContents = CCFileUtils:sharedFileUtils():getFileData(path,"r",len)
		local tmp = json.decode(fileContents)
		configChargeDaily={}
		for k,v in pairs(tmp) do
			configChargeDaily[tonumber(k)+1]=v
		end
		local path2 = getTmpPath() .. "/gamedata/config/testdailyrechargehero.json"
		fileContents2 = CCFileUtils:sharedFileUtils():getFileData(path2,"r",len)
		configChargeDailyHero = json.decode(fileContents2)
	end
	if nil == configChargeDaily[1] then
		local path = getTmpPath() .. "/gamedata/config/testdailyrecharge.json"
		len = 0
		fileContents = CCFileUtils:sharedFileUtils():getFileData(path,"r",len)
		tmp = json.decode(fileContents)
		configChargeDaily={}
		for k,v in pairs(tmp) do
			configChargeDaily[tonumber(k)+1]=v
		end
	end

	for i,v in ipairs(g_activity_now) do
		if v.ty==5 then
			local start=str2Time(v.s)
			if start<=time and start+v.t>time then
				if g_activity.CD and g_activity.CD[v.s] then
					if g_activity.CD[v.s][today] then
						for ii,vv in ipairs(v.info or configChargeDaily) do
							if g_activity.CD[v.s][today].v>=vv.recharge then
								if g_activity.CD[v.s][today].g==nil or g_activity.CD[v.s][today].g[ii]~=true then
									return true
								end
							end
						end
					end
				end
			end
		end
	end
	
	if g_localPlayer.CD_look then--查看过一次，以后都不在红点提示
		return false
	end
	for i,v in ipairs(g_activity_now) do
		if v.ty==5 then
			local start=str2Time(v.s)
			local time=os.time()
			if time>start and time<start+v.t then
				return true
			end
		end
	end
	return false
end

--是否有每日充值活动
function haveSingleCharge()
	--先查看是否有没领取的
	local time=os.time()
	local today=getDayStr(time)

	-- 1:没有活动  2:有活动，但没有检查过红点 3:有活动，检查过红点 4:有活动，且有未领取的奖励 5:有活动，其他状态未知

	local haveEvent= 1 -- 表示没有这个活动

	for i,v in ipairs(g_activity_now) do
		if v.ty==singleRechargeTy then

			haveEvent= 5 

			local start=str2Time(v.s)
			if start<=time and start+v.t>time then
				if g_activity.SC and g_activity.SC[v.s] and g_activity.SC[v.s] then
					
						for ii,vv in ipairs(v.info or configSingleCharge) do

							if 

                            g_activity.SC[v.s].v and 
                            (g_activity.SC[v.s].g == nil or g_activity.SC[v.s].g[ii]~=true) and 
                            g_activity.SC[v.s].v[vv.recharge]==2  

                            then --

									return 4 --有可以领取的奖励
							end
						end
				end
			end
		end
	end

	if haveEvent == 1 then --没有活动就立马关闭
		return 1
	end

	if g_localPlayer.SC_look then--查看过一次，以后都不在红点提示
		return 3 --检查过红点
	end

	for i,v in ipairs(g_activity_now) do
		if v.ty==singleRechargeTy then
			local start=str2Time(v.s)
			local time=os.time()
			if time>start and time<start+v.t then
				return 2 --没有检查过红点
			end
		end
	end

	return 1

end

--是否有打折武将
function haveDiscountHero()
	for i,v in ipairs(g_activity_now) do
		if v.ty==6 then
			local start=str2Time(v.s)
			local time=os.time()
			if time>=start and time<start+v.t then
				return true
			end
		end
	end
	return false
end

--是否将魂兑换
function haveEHActivity()
	if g_EH_look then
		return false
	end
	if not g_activity_now or not g_activity.EH then
		return false
	end
	if not g_activity.EH then
		return false
	end
	local time=os.time()
	for i,v in ipairs(g_activity_now) do
		if v.ty==6 then
			local start=str2Time(v.s)
			if time>=start and time<start+v.t then
				for i,v in ipairs(g_activity.EH.info) do
					if v.freeC<3 and time-v.freeT>7200 then 
						return true
					end
				end
			end
		end
	end
	return false
end

function haveQiXi()
	for i,v in ipairs(g_activity_now) do
		if v.ty==10 then
			local start=str2Time(v.s)
			local time=os.time()
			if time>start and time<start+v.t then
				if g_localPlayer.qixi_look~=v.s then
					return true
				else
					return false
				end
			end
		end
	end
	return false
end

function haveCharge9()
	for i,v in ipairs(g_activity_now) do
		if v.ty==13 then
			local start=str2Time(v.s)
			local time=os.time()
			if time>start and time<start+v.t then
				if g_localPlayer.charge9_look~=v.s then
					return true
				else
					local today=getDayStr(time)
					local RMB=g_charge9RMB
					if v.info and v.info.gold then
						RMB=roundOff(v.info.gold/10)
					end
					if g_activity.charge9 and g_activity.charge9[v.s] and g_activity.charge9[v.s][today] and g_activity.charge9[v.s][today].v and g_activity.charge9[v.s][today].v>=RMB and not g_activity.charge9[v.s][today].g then
						return true
					end
					return false
				end
			end
		end
	end
	return false
end

function haveCharge9Equip()
	for i,v in ipairs(g_activity_now) do
		if v.ty==44 then
			local start=str2Time(v.s)
			local time=os.time()
			if time>start and time<start+v.t then
				if g_localPlayer.Charge9Equip_look~=v.s then
					return true
				else
					local today=getDayStr(time)
					local rmb=roundOff(configXinZhuangBei.gold/10)
					if v.info then
						rmb=roundOff(v.info.gold/10)
					end
					if g_activity.Charge9Equip and g_activity.Charge9Equip[v.s] and g_activity.Charge9Equip[v.s][today] and g_activity.Charge9Equip[v.s][today].v and g_activity.Charge9Equip[v.s][today].v>=rmb and not g_activity.Charge9Equip[v.s][today].g then
						return true
					end
					return false
				end
			end
		end
	end
	return false
end

function haveHaohuaqiandao(info)
    for i, v in ipairs(g_activity_now) do
        if v.ty == 46 then
            local start = str2Time(v.s)
            local actStartTime = v.s
            local time = os.time()
            if time > start and time < start + v.t then
                if not g_activity.haohuaqiandao or not g_activity.haohuaqiandao[actStartTime] then
                    return false
                end
                if not g_activity.haohuaqiandao[actStartTime].gift then
                    return true
                end

                local xwjCF = info.info or configActivityHaohuaqiandao

                if g_activity.haohuaqiandao[actStartTime].addgold >= xwjCF.gold then
                    local nowtime = getDayTime()
                    local avtTime
                    local sum = 0
                    local ret = true
                    for k, v1 in pairs(g_activity.haohuaqiandao[actStartTime].gift) do
                        if g_activity.haohuaqiandao[actStartTime].gift[k].date ~= '' then
                            ret = false
                            avtTime = str2Time(g_activity.haohuaqiandao[actStartTime].gift[k].date .. " 00:00:00")
                            if nowtime == avtTime and g_activity.haohuaqiandao[actStartTime].gift[k].isget == 0 then
                                return true
                            end
                            if g_activity.haohuaqiandao[actStartTime].gift[k].isget == 1 then
                                sum = sum + 1
                            end
                        end
                    end
                    if ret then
                        return true
                    end
                    if sum == 7 and g_activity.haohuaqiandao[actStartTime].biggift.isget == 0 then
                        return true
                    end
                end

                return false
            else
                return false
            end
        end
    end
    return false
end

function haveTwoyear(info)
    for i, v in ipairs(g_activity_now) do
        if v.ty == 50 then
            local start = str2Time(v.s)
            local actStartTime = v.s
            local time = os.time()
            if time > start and time < start + v.t then
                if not g_activity.twoyear or not g_activity.twoyear[actStartTime] then
                    return false
                end
                if not g_activity.twoyear[actStartTime].gift then
                    return true
                end

                local xwjCF = info.info or configActivityTwoyear
                local nowtime = getDayTime()
                local avtTime
                local sum = 0
                local ret = true
                for k, v1 in pairs(g_activity.twoyear[actStartTime].gift) do
                    if g_activity.twoyear[actStartTime].gift[k].date ~= '' then
                        ret = false
                        avtTime = str2Time(g_activity.twoyear[actStartTime].gift[k].date .. " 00:00:00")
                        if nowtime == avtTime and g_activity.twoyear[actStartTime].gift[k].isget == 0 then
                            return true
                        end
                        if g_activity.twoyear[actStartTime].gift[k].isget == 1 then
                            sum = sum + 1
                        end
                    end
                end
                if ret then
                    return true
                end
                if sum == 7 and g_activity.twoyear[actStartTime].biggift.isget == 0 then
                    return true
                end
            else
                return false
            end
        end
    end
    return false
end

function haveShenjiangzaiqi(info)
    local time = os.time()
    local today = getDayStr(time)

    for k1, v1 in ipairs(g_activity_now) do
        if v1.ty == 48 then
            local start = str2Time(v1.s)
            if start <= time and start + v1.t > time then
                if g_activity.shenjiangzaiqi and g_activity.shenjiangzaiqi[v1.s] then
                    for kconf, vconf in pairs(configActivitySjDuan) do
                        local point = g_activity.shenjiangzaiqi[v1.s].mypoint or 0
                        if point >= configActivitySjDuan[kconf].points then
                            if g_activity.shenjiangzaiqi[v1.s].duan then
                                if g_activity.shenjiangzaiqi[v1.s].duan[kconf] ~= 1 then
                                    return true
                                end
                            else
                                return true
                            end
                        end
                    end
                end

                if not g_localPlayer.cdShenjiangzaiqi_look then
                    -- 查看过一次，以后都不在红点提示
                    return true
                end
            end
        end
    end
    return false
end

function haveZhuanPan()
	for i,v in ipairs(g_activity_now) do
		if v.ty==17 then
			local start=str2Time(v.s)
			local time=os.time()
			if time>start and time<start+v.t then
				if g_localPlayer.zhuanpan_look~=v.s then
					return true
				else
					if g_activity.ZP[v.s] and g_activity.ZP[v.s].cnt-g_activity.ZP[v.s].gcnt*50>=50 then
						return true
					end
					return false
				end
			end
		end
	end
	return false
end

function havePVPHD()
	for i,v in ipairs(g_activity_now) do
		if v.ty==18 then
			local start=str2Time(v.s)
			local time=os.time()
			if time>start and time<start+v.t then
				if g_localPlayer.PVPHD_look~=v.s then
					return true
				else
					return false
				end
			end
		end
	end
	return false
end

function haveThreeVisit()
	for i,v in ipairs(g_activity_now) do
		if v.ty==20 then
			local start=str2Time(v.s)
			local time=os.time()
			if time>start and time<start+v.t+86400 then
				if g_localPlayer.threeVisit_look~=v.s then
					return true
				else
					if g_activity then
						g_activity.threeVisit[v.s]=g_activity.threeVisit[v.s] or {}
						g_activity.threeVisit[v.s].freeCnt=g_activity.threeVisit[v.s].freeCnt or 0
						g_activity.threeVisit[v.s].freeDay=g_activity.threeVisit[v.s].freeDay or getDayStr(time)
						--有免费
						if time<start+v.t and (str2Time(g_activity.threeVisit[v.s].freeDay .. " 00:00:00")<getDayTime(time) or g_activity.threeVisit[v.s].freeCnt<g_threeVisitFreePerDay) then
							return true
						end
						g_activity.threeVisit[v.s].gold=g_activity.threeVisit[v.s].gold or 0
						g_activity.threeVisit[v.s].got=g_activity.threeVisit[v.s].got or 0
						g_activity.threeVisit[v.s].gotHero=g_activity.threeVisit[v.s].gotHero or 0
						local canCnt=math.floor(g_activity.threeVisit[v.s].gold/g_threeVisitPerGold)
						local hadCnt=math.max(0,canCnt)
						hadCnt=math.min(g_maxThreeVisitCnt,canCnt)
						local nowMaxCnt=math.max(0,math.ceil((os.time()-str2Time(v.s))/86400))*g_maxThreeVisitCntDay
						nowMaxCnt=math.min(g_maxThreeVisitCnt,nowMaxCnt)
						canCnt=math.min(canCnt,nowMaxCnt)
						canCnt=math.min(canCnt,g_maxThreeVisitCnt)
						canCnt=canCnt-g_activity.threeVisit[v.s].got
						if canCnt>0 or (g_activity.threeVisit[v.s].gotHero==0 and g_activity.threeVisit[v.s].gold>=g_threeVisitGold) then
							return true
						end
					end
					return false
				end
			end
		end
	end
	return false
end

--是否有可领副本礼包
function canGetCampaignGift()
	for i=0,g_player_info.maxCampaign-1 do
		if not g_player_info.campaignReward[i] then
			return true
		end
	end
	return false
end

--是否为开启新将星等级提示
function getNewStarLevel(level)
	if not configStarUnlock then
		return false
	end
	if level == g_localPlayer.starIgnorlevel then
		return false
	end
	local starNums = 0
	for i=#configStarUnlock["starunlock"],1,-1 do
		if level >= configStarUnlock["starunlock"][i]["herolevel"] then
			starNums = i
			break
		end
	end
	local curStarNums = 0
	for k,v in pairs(g_hero_list) do
		if v.mPos > 0 and v.mStars and #v.mStars > curStarNums then
			curStarNums = #v.mStars
		end
	end
	if curStarNums < starNums then
		return true
	end
	return false
end

--是否为缘分装备
function isRelationEquip(equipId,heroId)
	if configHeroes[heroId]["relationid"] then
		for i=1,#configHeroes[heroId]["relationid"] do
			local relationId = configHeroes[heroId]["relationid"][i]
			if "" == relationId or not relationId then
				break
			end
			if configRelations[relationId] and configRelations[relationId]["type"] == "equip" 
				and configRelations[relationId]["group"][1] == equipId then
				return true
			end
		end
	end
	return false
end

--获取缘分描述
function getRelationDesc(id,orangeLv)
	if not id or not configRelations[id] then
		return "None"
	end
	orangeLv=orangeLv or 0
	local desc = ""
	if "hero" == configRelations[id].type then
		for jj=1,6 do
			local heroId = configRelations[id]["group"][jj]
			local nextId = configRelations[id]["group"][jj+1]
			if nil ~= heroId and "" ~= heroId and json.null ~= heroId then
				strName = strName ..configHeroes[heroId].name
			else
				break
			end
			if nil ~= nextId and "" ~= nextId and json.null ~= nextId then
				strName = strName ..configStrings["str_comon"]
			end
		end
		local format = configStrings["str_relation_buzhen"]
		desc = desc .. string.format(format,strName)
	elseif "equip" == configRelations[id].type then
		local format = configStrings["str_relation_equip"]
		strName = configEquips[configRelations[id]["group"][1]].name
		desc = desc .. string.format(format,strName)
	elseif "book" == configRelations[id].type then
		local format = configStrings["str_relation_equip"]				
		strName = configBooks[configRelations[id]["group"][1]].name
		desc = desc .. string.format(format,strName)
	elseif "formation" == configRelations[id].type then
		local format = configStrings["str_relation_form"]
		strName = configFormations[configRelations[id]["group"][1]].name
		desc = desc .. string.format(format,strName)
	end					
	--显示属性增加
	local orangeAdd=0
	if orangeLv>0 then
		orangeAdd=configOrangeInfo[orangeLv].relationshipjiacheng
	end
	local strAdd = ""
	local addCnt=0
	for k,v in pairs(configRelations[id]["benefit"]) do
		addCnt=addCnt+1
	end
	addCnt=math.max(1,addCnt)
	table.foreach(configRelations[id]["benefit"],function(kk,vv)
		strAdd = strAdd .. string.format(" %s+%.2f%%%s",configStrings[kk],(vv+orangeAdd/addCnt)*100,configStrings["str_comon"])
		end)
	strAdd = string.sub(strAdd,1,string.len(strAdd)-string.len(configStrings["str_comon"]))
	desc = desc ..strAdd
	return desc
end

--装备是否比武将身上强
function isNewbilityEquip(newEquip)
	local replaceList = {}
	local newEquipOrgPower,newEquipAddPower=newEquip:getPower()
	for k,v in pairs(g_buzhen_list) do
		local newbility = false --新装备是否更牛
		local oldEquip = nil --原位置装备
		for kk,vv in pairs(g_equip_list) do
			if vv.mHeroId == v.mHeroId and vv.mSubType == newEquip.mSubType  then
				oldEquip = vv
			end
		end
		if oldEquip then
			if not isRelationEquip(oldEquip.mEquipId,v.mHeroId) then
				local oldEquipOrgPower = oldEquip:getPower()
				if newEquipOrgPower > oldEquipOrgPower then
					newbility = true
				end
			end
		else
			newbility = true
		end
				
		if newbility then
			table.insert(replaceList,v.mPos) 
		end
	end
	return replaceList
end

--获取武装出手时间和基本速度
function getPlayerOneFightTime()
	local speed = 1.5 + (g_player_info.level - 1) * 0.02
	if speed > 2 then
		speed = 2
	end
	local oneFightTime = G_ROUND_TIME*2/speed
	return oneFightTime,speed
end

--[[
--扫描背包是否存在更牛的装备没装上
function searchNewbilityEquip()
	local newbiltist = {}
	newbiltist["weapon"] = 0
	newbiltist["headdress"] = 0
	newbiltist["dress"] = 0
	newbiltist["accessory"] = 0
	newbiltist["shoes"] = 0
	for k,v in pairs(g_equip_list) do
		local orgPower,addPower = v:getPower()
		if newbiltist[v.mSubType] < orgPower then
			newbiltist[v.mSubType] = orgPower
		end
	end
	
	for k,v in pairs(g_buzhen_list) do
		local newbility = true --新装备是否更牛
		for kk,vv in pairs(g_equip_list) do
			if vv.mHeroId == v.mHeroId and vv.mSubType == newEquip.mSubType then
				local orgPower1,addPower1=newEquip:getPower()
				local orgPower2,addPower2=vv:getPower()
				if orgPower1 <= orgPower2 then
					newbility = false
					break
				end
			end
		end 
		if newbility then
			table.insert(replaceList,v.mPos) 
		end
	end
	local replaceList = isNewbilityEquip(newEquip)
					if #replaceList > 0 then
						addRedtip(GameMainScene.navHero,G_EQUIP_NEW)
						for _,pos in pairs(replaceList) do
							g_buzhen_list[pos].newEquip = g_buzhen_list[pos].newEquip or {}
							g_buzhen_list[pos].newEquip[newEquip.mSubType] = true
						end
					end
end
--]]
--获取玩家公会技能的增益
function getGuildSkillCampaignExp(  )
	-- body
	return math.max(1,1+g_guild_info.skill["campaignExp"]*configGuildSkill.campaignExp.everyLevelCapability)
end
--获取玩家公会技能的增益
function getGuildSkillCampaignCoin(  )
	-- body
	return math.max(1,1+g_guild_info.skill["campaignCoin"]*configGuildSkill.campaignCoin.everyLevelCapability)
end
--获取玩家公会技能的增益
function getGuildSkillUpEquipCoin(  )
	-- body
	return math.max(0,1-g_guild_info.skill["upEquipCoin"]*configGuildSkill.upEquipCoin.everyLevelCapability)
end
--获取玩家公会技能的增益
function getGuildSkillBaptizeEquipCoin(  )
	-- body
	return math.max(0,1-g_guild_info.skill["baptizeEquipCoin"]*configGuildSkill.baptizeEquipCoin.everyLevelCapability)
end
--获取玩家公会技能的增益
function getGuildSkillGetHero(  )
	-- body
	return math.max(0,1-g_guild_info.skill["getHero"]*configGuildSkill.getHero.everyLevelCapability)
end
--获取玩家公会技能的增益
function getGuildSkillBag(  )
	-- body
	return math.max(0,g_guild_info.skill["bag"]*configGuildSkill.bag.everyLevelCapability)
end

function formatCompHero(lghero)
    return string.format("%3d %8s %4d %4d %15f %15f %15f %15f %15f %15f %15f %15f %15f %15f %15f %15f %15f %15f %15f %15f %15f %15f %15f %15f\n",
        lghero.mPos,lghero.mHeroId,lghero.mLevel,lghero.mSkillLevel,lghero.mRealPd,
        lghero.mRealMd,lghero.mRealHr,lghero.mRealDr,lghero.mRealMr,
        lghero.mRealChr,lghero.mRealCrr,lghero.mCurHp,lghero.mRealCm,lghero.mRealRb,
        lghero.mRealSpd,lghero.mRealHp,lghero.mRealAp,lghero.mRealMp,lghero.mRealNp,
        lghero.mRealLead,lghero.mRealDex,lghero.mRealDp,lghero.mMinAp,lghero.mMaxAp)
end

--从文件中读取战斗项雄列表
function getHeroListFromFile(path)
	local f = assert(io.open(path,'r'))
	if not f then 
		return
	end
	local line = f:read()
	while line and not string.find(line,"randSeed") do
		line = f:read()
	end
	if not line then
		return
	end
	line = string.gsub(line,":","=")
	line = "local ".. line .. " return randSeed"
	local randSeed = loadstring(line)()
	
	local title = " pos  HeroId   Lv  skillLv    mRealPd         RealMd          RealHr          RealDr           RealMr         RealChr         RealCrr        mCurHp            RealCm          RealRb       RealSpd          RealHp          RealAp         RealMp           RealNp          RealLead        RealDex         RealDp          MinAp          MaxAp"
	while line and line ~= title do 
		line = f:read("*line")
	end
	local herolist = {}
	for i=1,18 do
		if not line then
			break
		end
		line = f:read("*line")
		line = string.gsub(line,"% +",",")
		line = string.sub(line,2,string.len(line))
		line = string.gsub(line,"(%a%a%d%d%d)",'%"%1%"')
		line = "local v = {" .. line .. "} return v"
		local data = loadstring(line)()
		if type(data[2]) == "number" then
			table.insert(data,2,"")
		end
		local lghero = {}
		lghero.mPos = data[1]
		lghero.mHeroId = data[2]
		lghero.mLevel= data[3]
		lghero.mSkillLevel= data[4]
		lghero.mRealPd = data[5]
        lghero.mRealMd = data[6]
		lghero.mRealHr = data[7]
		lghero.mRealDr = data[8]
		lghero.mRealMr = data[9]
        lghero.mRealChr = data[10]
		lghero.mRealCrr = data[11]
		lghero.mCurHp = data[12]
		lghero.mRealCm = data[13]
		lghero.mRealRb = data[14]
        lghero.mRealSpd = data[15]
		lghero.mRealHp = data[16]
		lghero.mRealAp = data[17]
		lghero.mRealMp = data[18]
		lghero.mRealNp = data[19]
        lghero.mRealLead = data[20]
		lghero.mRealDex = data[21]
		lghero.mRealDp = data[22]
		lghero.mMinAp = data[23]
		lghero.mMaxAp = data[24]
		herolist[i] = lghero
	end
	io.close(f)
	return {hero = herolist, randseed = randSeed }
end

function playbutton()
	SimpleAudioEngine:sharedEngine():playEffect("gamedata/sound/button.mp3")
end
function playequip()
	SimpleAudioEngine:sharedEngine():playEffect("gamedata/sound/equip.mp3")
end
function playpanel()
	SimpleAudioEngine:sharedEngine():playEffect("gamedata/sound/panel.mp3")
end
function playronglian()
	SimpleAudioEngine:sharedEngine():playEffect("gamedata/sound/ronglian.mp3")
end
function playbloodfail()
	SimpleAudioEngine:sharedEngine():playEffect("gamedata/sound/bloodfail.mp3")
end
function playding()
	SimpleAudioEngine:sharedEngine():playEffect("gamedata/sound/ding.mp3")
end
function playqianghua()
	SimpleAudioEngine:sharedEngine():playEffect("gamedata/sound/qianghua.mp3")
end
function playupgrade()
	SimpleAudioEngine:sharedEngine():playEffect("gamedata/sound/upgrade.mp3")
end
function playfail()
	SimpleAudioEngine:sharedEngine():playEffect("gamedata/sound/fail.mp3")
end
function playgethero()
	SimpleAudioEngine:sharedEngine():playEffect("gamedata/sound/gethero.mp3")
end
function playeat()
	SimpleAudioEngine:sharedEngine():playEffect("gamedata/sound/eat.mp3")
end
function playgetitem()
	SimpleAudioEngine:sharedEngine():playEffect("gamedata/sound/getitem.mp3")
end
function playpopreward()
	SimpleAudioEngine:sharedEngine():playEffect("gamedata/sound/popreward.mp3")
end
function playpanelmove()
	SimpleAudioEngine:sharedEngine():playEffect("gamedata/sound/panelmove.mp3")
end
function playcost()
	SimpleAudioEngine:sharedEngine():playEffect("gamedata/sound/cost.mp3")
end

function playEffectSound(sound,delay,node)
	if 3 ~= GameMainScene.current_page and not effectDebug then
		return
	end
	delay = delay or 0
	delay = delay * 1.0/g_fight_speed
	if not sound or sound == "" or not node then
		return
	end

	local file = "gamedata/sound/battle/"..sound..".mp3"
	local fullpathFile = getTmpPath() .. "/" .. file

	if exist(fullpathFile) then
		file = fullpathFile
	elseif not exist(file) then
		return
	end
	performWithDelay(node,function()
		SimpleAudioEngine:sharedEngine():playEffect(file)
	end,delay)
end

function downVersion()
	local fullpathFile = getTmpPath() .. "/ver"
	local len = 0
	local fileContents = CCFileUtils:sharedFileUtils():getFileData(fullpathFile,"r",len)
	if fileContents ~= nil and fileContents ~= "" then
		local t={}
		for v in string.gmatch(fileContents, "[%d]+") do
			table.insert(t,tonumber(v))
		end
		for i=#t,1,-1 do
			if t[i]>0 then
				t[i]=t[i]-1
				break
			end
		end
		local s=""
		for i,v in ipairs(t) do
			s=s .. v
			if i~=#t then
				s=s .. "."
			end
		end
		local f = io.open(fullpathFile,"w")
		if nil == f then
			return popup_main(ls('打开文件失败'))
		end
		f:write(s)
		f:close()
		return MyMessageBox(ls('回退版本成功:').. s)
	else
		return popup_main(ls('无版本信息'))
	end
end

--[[
local _myDraw = nil
local MyLabelTTF = class("MyLabelTTF", function()
    local labelttf = CCLabelTTF:create()
    -- save c++ member method point.
    _myDraw = labelttf.draw
    return labelttf
end)

function MyLabelTTF:draw()
	drawSegment(
	_myDraw(self)
end
--]]


--[[string     文本

*fontName   文本字体类型

*fontSize   文本大小

*color3     文本颜色

*lineWidth  所描边的宽度

]]
 function textAddStroke(content, fontSize,color3,bgColor,lineWidth)
--/* 正文CCLabelTTF */
	local center = CCLabelTTF:create()
	center:setFontSize(fontSize)
	center:setString(content)
	center:setColor(color3)

	local node = CCNode:create()
	local sz = center:getContentSize()
	local scale = center:getScale()
	sz.width = sz.width * scale
	sz.height = sz.height * scale
	
	node:setContentSize(sz)
	node:addChild(center)
	center:setAnchorPoint(ccp(0,0))
	if content == "" then
		return node
	end
	--/* 描边CCLabelTTF 上 */
	local  up = CCLabelTTF:create()
	up:setString(content)
	up:setFontSize(fontSize)
	up:setColor(bgColor)
	up:setPosition(ccp(0, 0+lineWidth))
	up:setAnchorPoint(ccp(0,0))
	node:addChild(up,-1)

	--/* 描边CCLabelTTF 下 */

	local  down = CCLabelTTF:create()
	down:setString(content)
	down:setFontSize(fontSize)
	down:setColor(bgColor)
	down:setPosition(ccp(0, 0-lineWidth))
	down:setAnchorPoint(ccp(0,0))
	node:addChild(down,-1)

	--/* 描边CCLabelTTF 左 */

	local  left = CCLabelTTF:create()
	left:setString(content)
	left:setFontSize(fontSize)
	left:setColor(bgColor)
	left:setPosition(ccp(0-lineWidth, 0))
	left:setAnchorPoint(ccp(0,0))
	node:addChild(left,-1)

	--/* 描边CCLabelTTF 右 */

	local  right = CCLabelTTF:create()
	right:setString(content)
	right:setFontSize(fontSize)
	right:setColor(bgColor)
	right:setPosition(ccp(0+lineWidth,0))
	right:setAnchorPoint(ccp(0,0))
	node:addChild(right,-1)

	return node
end

function firstCaseNotNum(name)
	local firstChar = string.sub(name,1,1)
	for i=0,9 do
		if firstChar == tostring(i) then
			return false
		end
	end
	return true
end

g_MVCInfo={}
function registerMyNotification(obj,fun,name)
	if not g_MVCInfo[name] then
		g_MVCInfo[name]={}
	end
	
	table.insert(g_MVCInfo[name],{fun=fun,obj=obj})
end
function unregisterMyNotification(obj,name)
	if g_MVCInfo[name] then
		for i,v in ipairs(g_MVCInfo[name]) do
			if v.obj==obj then
				table.remove(g_MVCInfo[name],i)
				break
			end
		end
	end
end

function postMyNotification(name,...)
	if g_MVCInfo[name] then
		local t={}
		for i,v in ipairs(g_MVCInfo[name]) do
			table.insert(t,v.fun)
		end
		--防止在fun执行的时候删除notification导致有些notification不执行
		for i,v in ipairs(t) do
			v(name,...)
		end
	end
end

function string.split(str, delim)
    local res = {}
    local pattern = string.format("([^%s]+)", delim)

    for line in str:gmatch(pattern) do
        table.insert(res, line)
    end
    return res
end

function compareVersion( ver1,ver2 )
    ver1=ver1 or ""
    ver2=ver2 or ""
    local t1=string.split(ver1,".")
    local t2=string.split(ver2,".")
    if #t1>#t2 then 
        return true 
    elseif #t2>#t1 then 
        return false 
    else 
        for i,v in ipairs(t1) do
            if tonumber(v)>tonumber(t2[i]) then 
                return true
            elseif tonumber(v)<tonumber(t2[i]) then 
                return false
            end
        end
    end
end
--打乱table中顺序
function RandTable( t )
    local ret={}
    while #t~=0 do 
        local r=rand(1,#t)
        table.insert(ret,t[r])
        table.remove(t,r)
    end
    return ret
end
--从droplist中4选1中选出id。可能包含多个4选1的id
function selectIdsFromMultiFour(dl,fun)
	local index=0
	local ids={}
	local function tmpF(itemId)
		table.insert(ids,itemId)
		index=index+1
		if index>#dl then
			fun(ids)
		else
			local id=dl[index].id
			if type(id)=="table" then
				if string.sub(dl[index].id[1],1,1)=="H" then
					doModal(nil,selectOneHeroFromFour(dl[index],tmpF))
				else
					doModal(nil,selectOneEquipFromFour(dl[index],tmpF))
				end
			else
				tmpF(nil)
			end
			
		end
	end
	tmpF(nil)
end

--显示物品node
function displayNode(nodeScene,key,v)
	if not nodeScene[key] then
		return
	end
	local assetId,name,fnt,gd
	if type(v.id)=="table" then
		name=ls('武将魂礼包')
		fnt="gamedata/font/loliA24.fnt"
		gd="A"
		if string.sub(v.id[1],1,1)=="E" then
			name=ls('装备礼包')
			fnt="gamedata/font/loliX24.fnt"
			gd="X"
		elseif string.sub(v.id[1],1,1)=="I" then
			name=ls('道具礼包')
		end
		assetId="IE017.png"
	else
		assetId,name,fnt,gd=getInfoFromDrop(v)
		if string.sub(v.id,1,4)=="skin" then
			--nodeScene[key.."_Xhero"]:setVisible(true)
		else
			--nodeScene[key.."_Xhero"]:setVisible(false)
		end
	end
	
	nodeScene[key.."_str_name"]:setString("")
	nodeScene[key.."_str_name"]:setFntFile(fnt)
	nodeScene[key.."_str_name"]:setString(name)
	local pFrame=CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName(assetId)
	if pFrame then
		nodeScene[key.."_icon"]:setDisplayFrame(pFrame)
	end
	nodeScene[key.."_gradeX"]:setVisible(false)
	nodeScene[key.."_gradeS"]:setVisible(false)
	nodeScene[key.."_gradeA"]:setVisible(false)
	nodeScene[key.."_gradeB"]:setVisible(false)
	nodeScene[key.."_gradeC"]:setVisible(false)
	nodeScene[key.."_gradeD"]:setVisible(false)
	nodeScene[key.."_grade"..gd]:setVisible(true)
	nodeScene[key.."_bg"]:setDisplayFrame(CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("jinengkuangBg"..gd..".png"))
	if v.num then
		nodeScene[key.."_str_count"]:setString("x".. v.num)
	else
		nodeScene[key.."_str_count"]:setString("")
	end
	if gd=="X" then
		nodeScene[key.."_effectYuan"]:setVisible(true)
	end
	if v.isFragment == true then
		if not nodeScene[key.."_xxspxx"] then
			local tex = CCSprite:create()
			local fragIcon = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("equip_fragment.png")
			tex:setDisplayFrame(fragIcon)
			tex:setPosition(ccp(30,105))
			tex:setAnchorPoint(ccp(0,0.5))
			nodeScene[key]:addChild(tex)
			nodeScene[key.."_xxspxx"]=tex
		end
		nodeScene[key.."_xxspxx"]:setVisible(true)
	else
		if nodeScene[key.."_xxspxx"] then
			nodeScene[key.."_xxspxx"]:setVisible(false)
		end
	end
end

function readTempFileData(fileName)
	if type(fileName)~="string" then
		return
	end
	local fullPath = CCFileUtils:sharedFileUtils():getWritablePath()..fileName
	local f=io.open(fullPath,"r")
	if nil==f then
		return
	end
	local fileContents = f:read("*all")
	f:close()
	return fileContents
end
function writeTempFileData(fileName,data)
	if type(fileName)~="string" or type(data)~="string" then
		return
	end
	local fullPath = CCFileUtils:sharedFileUtils():getWritablePath()..fileName
	local f=io.open(fullPath,"w")
	if nil==f then
		return false
	end
	f:write(data)
	f:close()
	return true
end

function getAniAssetId(lghero)
	if lghero.curSkin and configSkinAttr[lghero.curSkin] then
		return configSkinAttr[lghero.curSkin].assetId
	else
		return lghero.mAssetId or configHeroes[lghero.mHeroId].assetId
	end
end
--滑动列表移动函数
function onScViewTop (scView,width)

	if not enterStbCode() then

			return

	end

	if scView == nil or tolua.type(scView) ~="CCScrollView" then
		cclog(" scView  is nil value or not was CCScrollView")
		return
	end
	local num = with or 50
 	local containeSize =scView:getContentSize()
	local ViewSize = scView:getViewSize()
	local offset =scView:getContentOffset().y
	local offsetX = scView:getContentOffset().x
    local maxOffset = -(containeSize.height - ViewSize.height) 
    local prentOffx = offset - maxOffset
    if prentOffx>num then
        scView:setContentOffset(ccp(offsetX,offset-num))
    elseif prentOffx<=num and prentOffx>0 then
        scView:setContentOffset(ccp(offsetX,maxOffset))
    else
        stb_focusOpt_setIsScView(false)
    end
 end

 function onScViewButtom(scView,width)

 	if not enterStbCode() then

 		return

 	end

 	if scView ==nil or tolua.type(scView) ~="CCScrollView" then
		cclog(" scView  is nil value or not was CCScrollView")
		return
	end
	local num = with or 60
  	local containeSize = scView:getContentSize()
    local ViewSize = scView:getViewSize()
	local offset = scView:getContentOffset().y
	local offsetX = scView:getContentOffset().x
    local maxOffset = containeSize.height - ViewSize.height 
    local prentOffx = offset + maxOffset
    if prentOffx<maxOffset-num then
       scView:setContentOffset(ccp(offsetX,offset+num))
    elseif prentOffx < maxOffset and prentOffx> maxOffset-num then
        scView:setContentOffset(ccp(offsetX,0))
    else
        stb_focusOpt_setIsScView(false)
    end
 end 